#!/bin/sh
# 05/06/2003

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

#TODO: - README suggests running 'autoheader' *and* 'autoconf', but
#TODO: running 'autoheader' as per claims "missing templates" :(
#TODO: - No create_reg_key() building host utilities
#TODO: - host -> cross compilation by removing 'arj' fails on linking

make_build()
{
# CONFIGURE...
	( cd gnu && ( \
	autoconf && \
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc \
		./configure \
		 --prefix=/usr \
		 --build=`uname -m` --host=${TARGET_CPU} --target=${TARGET_CPU} \
		 || exit 1 ;\
	) || exit 1 ) || exit 1

	[ -r GNUmakefile.OLD ] || cp GNUmakefile GNUmakefile.OLD
	cat GNUmakefile.OLD \
		| sed 's/-O2 -O2/-O2/' \
		> GNUmakefile
	echo -n "localhost_tools: " >> GNUmakefile
	for PROG in `grep "TOOLS_DIR.*x:" GNUmakefile | sed 's/:.*//'` ; do
		echo -n " $PROG" >> GNUmakefile
	done
	echo >> GNUmakefile

# BUILD...
	make CC=gcc prepare localhost_tools || exit 1
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make CC=${TARGET_CPU}-uclibc-gcc DYN_LIBS=-ldl none/en/rs/arj/arj || exit 1

# INSTALL...
	make DESTDIR=${INSTTEMP} install || exit 1
}

#make_toolchain()
#{
#	./configure --prefix=${INSTTEMP}/usr --bindir=${INSTTEMP}/bin || exit 1
#	make || exit 1
#	make install || exit 1
#}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
#toolchain)
#	INSTTEMP=${TCTREE} make_toolchain || exit 1
#	;;
*)
	exit 1
	;;
esac
