#!/bin/sh
# 04/07/2003

#TODO: suffers various redefinitions (eg "struct sockaddr")

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	cat > Makefile <<EOF
#!/bin/gmake

# means of making objects with the cross compiler (WmT, 05/06/2003)
.c.o:
	\${CROSS}gcc \${CFLAGS} -c $< -o \$@

EOF
	cat Makefile.linux \
		| sed 's/^	gcc/	$(CROSS)gcc/' \
		| sed 's/^OBJS1 =/OBJS1= socket.o options.o files.o/' \
		>> Makefile

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make CFLAGS="-nostdinc -I${TCTREE}/usr/include -I${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/include -I${TCTREE}/usr/lib/gcc-lib/i686-linux-gnu/2.95.3/include" CROSS=${TARGET_CPU}-uclibc- all || exit 1

# INSTALL...
	mkdir -p ${INSTTEMP}/etc/dhcpd || exit 1
	mkdir -p ${INSTTEMP}/usr/sbin || exit 1
	cp dhcpd ${INSTTEMP}/usr/sbin || exit 1
	cp tools/makeiplist tools/browseiplist ${INSTTEMP}/usr/sbin || exit 1
	cp samples/dhcpd.conf ${INSTTEMP}/etc/dhcpd/dhcpd.conf.sample || exit 1
	cp samples/dhcpd.iplist ${INSTTEMP}/etc/dhcpd/dhcpd.iplist.sample || exit 1
}

#make_toolchain()
#{
#	./configure --prefix=${INSTTEMP}/usr || exit 1
#	make || exit 1
#	make DESTDIR=/ install || exit 1
#}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
#toolchain)
#	INSTTEMP=${TCTREE} make_toolchain || exit 1
#	;;
*)
	exit 1
	;;
esac
