#!/bin/sh
# 05/06/2003

#TODO: - Fails to link against 'nr_inodes' (which appears to have a
#TODO: declaration in the kernel's sources, but not the package's)

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	  CC=${TARGET_CPU}-uclibc-gcc \
		./configure \
		 --build=`uname -m` --host=${TARGET_CPU} --target=${TARGET_CPU} \
		 --prefix=/usr \
		 --disable-nls --disable-largefile || exit 1

	[ -r src/main.h.OLD ] || cp src/main.h src/main.h.OLD
	cp src/main.h.OLD src/main.h
	cat <<"EOP" | patch -i - src/main.h
12a13
> #ifdef REENABLE_LARGEFILE
13a15,17
> #else
> extern int nr_inodes;
> #endif
EOP
	[ -r src/main.c.OLD ] || cp src/main.c src/main.c.OLD
	cp src/main.c.OLD src/main.c
	cat <<"EOP" | patch -i - src/main.c
7c7
< //#include <fcntl.h>
---
> #ifdef REENABLE_LARGEFILE
8a9,11
> #else
> #include <fcntl.h>
> #endif
30a34
> #ifdef ENABLE_LARGEFILE
31a36,40
> #else
> #if 0	/* UNUSED */
> unsigned int nr_inodes = 0;	/* number of FOUND inodes */
> #endif
> #endif
80a90
> #ifdef REENABLE_LARGEFILE
81a92,94
> #else
> 	if ((i = open(argv[optind], O_RDONLY)) == -1) {
> #endif
91a105
> #ifdef REENABLE_LARGEFILE
94a109,113
> #else
> 	else if (fstat(i, &st) == 0) {
> 		fs_size = (unsigned long long) st.st_size;
> 	}
> #endif
104a124
> #ifdef REENABLE_LARGEFILE
106a127,130
> #else
> 	fprintf(stderr, "File `%s' successfully opened with filesize %u bytes.\n",
> 			argv[optind], fs_size);
> #endif
143a168
> #ifdef REENABLE_LARGEFILE
144a170,172
> #else
> 		if ((i = open(argv[optind], O_RDWR)) == -1) {
> #endif
EOP

	[ -r src/config.h.OLD ] || cp src/config.h src/config.h.OLD
	cat src/config.h.OLD \
		| sed 's%I_CHECKED_CONFIG 0%I_CHECKED_CONFIG 1%' \
		> src/config.h
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make || exit 1
	make prefix=${INSTTEMP}/usr install || exit 1
}

make_toolchain()
{
	./configure --prefix=${INSTTEMP}/usr || exit 1
	make || exit 1
	make prefix=${INSTTEMP}/usr install || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain)
	INSTTEMP=${TCTREE} make_toolchain || exit 1
	;;
*)
	exit 1
	;;
esac
