#!/bin/sh -x
# 05/06/2003

#TODO: willow "unspecified build type"
#TODO: (build) regex_internal.h parse error "before 'wchar_t'"

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	[ -r Makefile.in.backup ] || cp awklib/Makefile.in awklib/Makefile.in.backup || exit 1
	cat awklib/Makefile.in.backup \
		| sed '/^datadir/s/awk/gawk/' \
		| sed '/^libexecdir/s%/awk%%' \
		> awklib/Makefile.in || exit 1

	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc \
		./configure --prefix=/usr --libexecdir=/usr/bin \
		 --host=`uname -m` --build=${TARGET_CPU} --target=${TARGET_CPU} \
		 --disable-nls \
		 || exit 1

#	[ -r config.h.OLD ] || mv config.h config.h.OLD
#	cat config.h.OLD \
#		| sed 's/.*HAVE_WCHAR_H.*/#undef HAVE_WCHAR_H/' \
#		| sed 's/.*HAVE_WCTYPE_H.*/#undef HAVE_WCTYPE_H/' \
#		> config.h

#	for F in regex_internal.h ; do
#		[ -r $F.OLD ] || mv $F $F.old
#		sed 's/_LIBC/_LIBC_NOT_UCLIBC/' $F.OLD > $F
#	done

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make || exit 1

# INSTALL...
	make PREFIX=${INSTTREE} install || exit 1
	( cd ${INSTTREE}/usr/bin && ( \
		rm *gawk-* ;\
		ln -sf gawk awk \
	) || exit 1 ) || exit 1
}

make_toolchain()
{
	[ -r Makefile.in.backup ] || cp awklib/Makefile.in awklib/Makefile.in.backup
	sed	-e '/^datadir/s/awk/gawk/' \
		-e '/^libexecdir/s%/awk%%' awklib/Makefile.in.backup \
		> awklib/Makefile.in
	./configure --prefix=${INSTTREE}/usr --libexecdir=${INSTTREE}/usr/bin \
	   --disable-nls \
	   --build=`uname -m` \
	   || exit 1
	make || exit 1
	make install || exit 1
	( cd ${INSTTREE}/usr/bin && ( \
		rm *gawk-* ;\
		ln -sf gawk awk \
	) || exit 1 ) || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain)
	INSTTREE=${TCTREE} make_toolchain || exit 1
	;;
*)
	exit 1
	;;
esac
