#!/bin/sh
# 05/06/2003

#TODO: willow tcbuild fails, lacking 'io.h'
#TODO: is it sane to define HAVE_DOS_FILE_*
#TODO: 'build' fixed with --disable-perl-regexp
#TODO: 'build' needs gettext still - or linking fails

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# need the included gettext, but specification seems to be ignored :(
# CPPFLAGS setting suggested for glibc=2.1.x:
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc \
	 CPPFLAGS=-Dre_max_failures=re_max_failures2 \
		./configure --prefix=/usr --bindir=/bin \
		 --build=`uname -m` --host=${TARGET_CPU} --target=${TARGET_CPU} \
		 --disable-nls --disable-largefile --disable-perl-regexp \
		 --with-included-gettext \
		 || exit 1
	[ -r src/Makefile.OLD ] || cp src/Makefile src/Makefile.OLD
	cat src/Makefile.OLD \
		| sed 's%ln -s %ln -sf %' \
		> src/Makefile
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make || exit 1
	make prefix=${INSTTEMP}/usr bindir=${INSTTEMP}/bin install \
	 || exit 1
}

make_toolchain()
{
# CPPFLAGS setting suggested for glibc=2.1.x:
	CPPFLAGS=-Dre_max_failures=re_max_failures2 \
		./configure --prefix=${INSTTEMP}/usr --bindir=${INSTTEMP}/bin --disable-nls || exit 1
	[ -r src/Makefile.OLD ] || cp src/Makefile src/Makefile.OLD
	cat src/Makefile.OLD \
		| sed 's%ln -s %ln -sf %' \
		> src/Makefile
	make || exit 1
	make prefix=${INSTTEMP}/usr bindir=${INSTTEMP}/bin install \
	 || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain)
	INSTTEMP=${TCTREE} make_toolchain || exit 1
	;;
*)
	exit 1
	;;
esac
