#!/bin/sh
# 30/05/2003

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc \
		./configure --prefix=/usr \
		 --build=`uname -m` --host=${TARGET_CPU} \
		 --disable-nls \
		 || exit 1

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make || exit 1

# INSTALL...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make DESTDIR=${INSTTEMP} install || exit 1
	( cd ${INSTTEMP}/usr/bin && ( \
		[ -r gunzip ] && rm gunzip ;\
		ln -s gzip gunzip ;\
		[ -r zcat ] && rm zcat ;\
		ln -s gzip zcat ;\
		[ -r zdiff ] && rm zdiff ;\
		ln -s zcmp zdiff ;\
		[ -r zegrep ] && rm zegrep ;\
		ln -s zgrep zegrep ;\
		[ -r zfgrep ] && rm zfgrep ;\
		ln -s zgrep zfgrep ;\
	) || exit 1 ) || exit 1
}

make_toolchain()
{
# CONFIGURE...
	./configure --prefix=${INSTTEMP}/ \
	 || exit 1

# BUILD...
	make || exit 1

# INSTALL...
	make DESTDIR=${INSTTEMP} install || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain)
	INSTTEMP=${TCTREE} make_toolchain || exit 1
	;;
*)
	exit 1
	;;
esac
