#!/bin/sh
# 25/05/2003

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
	mkdir -p ${SOURCETMP}/gcc-build
	( cd ${SOURCETMP}/gcc-build && \
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 AR_FOR_TARGET=${TARGET_CPU}-uclibc-ar \
	 AS_FOR_TARGET=${TARGET_CPU}-uclibc-as \
	 CC_FOR_TARGET=${TARGET_CPU}-uclibc-gcc \
	 GCC_FOR_TARGET=${TARGET_CPU}-uclibc-gcc \
	 CXX_FOR_TARGET=${TARGET_CPU}-uclibc-g++ \
	 LD_FOR_TARGET=${TARGET_CPU}-uclibc-ld \
	 NM_FOR_TARGET=${TARGET_CPU}-uclibc-nm \
	 RANLIB_FOR_TARGET=${TARGET_CPU}-uclibc-ranlib \
		${SOURCETMP}/${SRCXPATH}/configure \
		 --host=${TARGET_CPU}-linux --target=${TARGET_CPU}-linux \
		 --prefix=${INSTTEMP}/usr \
		 --disable-nls --disable-largefile \
		 --enable-languages=c \
		 --enable-target-optspace \
		 || exit 1 ;\

	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make bootstrap || exit 1 ;\

	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make || exit 1 ;\

	make install || exit 1 \
	) || exit 1
}

make_toolchain()
{
	mkdir -p ${SOURCETMP}/gcc-build
	( cd ${SOURCETMP}/gcc-build && \
		${SOURCETMP}/${SRCXPATH}/configure \
		 --prefix=${INSTTEMP}/usr \
		 --enable-languages=c,c++ \
		 --disable-nls --disable-largefile \
			|| exit 1 ;\
		make bootstrap || exit 1 ;\
		make || exit 1 ;\
		make install || exit 1 \
	) || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain)
	INSTTEMP=${TCTREE} make_toolchain || exit 1
	;;
*)
	exit 1
	;;
esac
