#!/bin/sh
# 05/06/2003

#TOOD: complaint "shared libraries not supported in this version"
#TODO: runtime not sane - get "Error opening terminal"

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 BUILD_CC=gcc HOSTCC=gcc CC=${TARGET_CPU}-uclibc-gcc \
		./configure --prefix=/usr --with-install-prefix=${INSTTEMP} \
		 --build=`uname -m` --host=${TARGET_CPU} --target=${TARGET_CPU} \
		 --disable-nls --disable-largefile \
		 --disable-termcap \
		 --without-cxx --without-cxx-binding --without-ada \
		 --with-normal --without-debug \
		 || exit 1

# BUILD...
	make -C include sources || exit 1
	make -C ncurses CC=gcc make_keys make_hash || exit 1
	make -C progs transform.h || exit 1
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make -C progs all || exit 1

# INSTALL...
#	make DESTDIR=${INSTTEMP} install || exit 1
	make install.includes || exit 1
#	make install.libs || exit 1
	make install.ncurses || exit 1
	make install.man || exit 1
}

make_toolchain()
{
# CONFIGURE...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 BUILD_CC=gcc HOSTCC=gcc CC=${TARGET_CPU}-uclibc-gcc \
		./configure --prefix=${INSTTEMP}/usr/${TARGET_CPU}-linux-uclibc \
		 --build=`uname -m` --host=${TARGET_CPU} --target=${TARGET_CPU} \
		 --disable-nls --disable-largefile \
		 --disable-termcap \
		 --without-cxx --without-cxx-binding --without-ada \
		 --with-normal --without-debug \
		 || exit 1

# BUILD...
	make -C include sources || exit 1
	make -C ncurses CC=gcc make_keys make_hash || exit 1
	make -C progs transform.h || exit 1
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make -C progs all || exit 1

# INSTALL...
	make install.includes || exit 1
	make install.ncurses || exit 1
	make install.man || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain)
	INSTTEMP=${TCTREE} make_toolchain || exit 1
	;;
*)
	exit 1
	;;
esac
