#!/bin/sh
# 16/06/2003

#TODO: hard dependency on 'cmp'
#TODO: expects 'cc' by default (...how to specify?) CAN we cross build?
#TODO: willow doesn't bail out if 'awk' not found
#TODO: ends up assuming various LARGE_FILE related things :(

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	[ ! -r config.sh ] || rm -f config.sh
	[ ! -r Policy.sh ] || rm -f Policy.sh
	[ -r Configure.OLD ] || mv Configure Configure.OLD || exit 1
	cat Configure.OLD \
		| sed "s/^cc=''/cc=${TARGET_CPU}-uclibc-gcc/" \
		| sed "s%'/bin %'${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin /bin%" \
		> Configure || exit 1
	sh Configure -de || exit 1
##	--
	[ -r config.sh.OLD ] || cp config.sh config.sh.OLD
	cat config.sh.OLD \
		| sed "s^usr/local^/usr/local^" \
		> config.sh

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make || exit 1

# TEST...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make test || true

# INSTALL...
	make bin=${INSTTEMP}/usr/bin scriptdir=${INSTTEMP}/usr/bin man1dir=${INSTTEMP}/usr/man/man1 man3dir=${INSTTEMP}/usr/man/man3 install \
	 || exit 1
}

make_toolchain()
{
	[ ! -r config.sh ] || rm -f config.sh
	[ ! -r Policy.sh ] || rm -f Policy.sh
	sh Configure -de
##	--
	[ -r config.sh.OLD ] || cp config.sh config.sh.OLD
	cat config.sh.OLD \
		| sed "s^usr/local^${INSTTEMP}/usr/local^" \
		> config.sh
##	--
	make || exit 1
	make test || true
	make bin=${INSTTEMP}/usr/bin scriptdir=${INSTTEMP}/usr/bin man1dir=${INSTTEMP}/usr/man/man1 man3dir=${INSTTEMP}/usr/man/man3 install || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain)
	INSTTEMP=${TCTREE} make_toolchain || exit 1
	;;
*)
	exit 1
	;;
esac
