#!/bin/sh
# 04/07/2003

# TODO: - Build fails - getline.c has conflicting types (and can't
# TODO: seem to ./configure it not to use the internal one)

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
#	 ac_cv_func_getline=yes \
#	 ac_cv_func_working_getline=yes \
#	 am_getline_needs_run_time_check=yes \
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc \
		./configure --prefix=/usr --bindir=/bin \
		 --build=`uname -m` --host=${TARGET_CPU} --target=${TARGET_CPU} \
		 --disable-largefile \
		 --disable-getline \
		 --without-included-getline \
		 --with-included-getline=no \
		 || exit 1

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make || exit 1

# INSTALL...
	make DESTDIR=${INSTTEMP} install || exit 1
}

make_toolchain()
{
	./configure --prefix=${INSTTEMP}/usr --bindir=${INSTTEMP}/bin || exit 1
	make || exit 1
	make install || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain)
	INSTTEMP=${TCTREE} make_toolchain || exit 1
	;;
*)
	exit 1
	;;
esac
