#!/bin/sh
# 25/06/2003

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	perl Makefile.PL
	mv Makefile Makefile.OLD || exit 1
	cat Makefile.OLD \
		| sed 's/^CC[ =].*/CC=${CROSS}gcc/' \
		> Makefile || exit 1

# BUILD...
# ...not sure we actually do any compilation (WmT, 25/06/2003)
#	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH}
		make CROSS=${TARGET_CPU}-uclibc- || exit 1

# INSTALL...
	make PREFIX=${INSTTEMP}/usr VARPREFIX=${INSTTEMP}/var install || exit 1
	( cd ${INSTTEMP}/usr/bin && ( \
		sed "s%${TCTREE}%%" alien > tmp.$$ || exit 1 ;\
		mv tmp.$$ alien || exit 1 ;\
		chmod a+x alien || exit 1 \
	) || exit 1 ) || exit 1
}

make_tc_host()
{
# CONFIGURE...
	perl Makefile.PL

# BUILD...
	make || exit 1

# INSTALL...
	make PREFIX=${TCTREE}/usr VARPREFIX=${TCTREE}/var install || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac
