#!/bin/sh
# 27/06/2003

# TODO:- willow has undefined references to fputc*()

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} CC=${TARGET_CPU}-uclibc-gcc \
	 CC=${TARGET_CPU}-uclibc-gcc CC_FOR_BUILD=gcc \
	 ac_cv_func_setvbuf_reversed=no \
	 bash_cv_have_mbstate_t=yes \
		./configure --prefix=/usr --bindir=/bin \
		 --host=`uname -m` --build=${TARGET_CPU} \
		 --disable-nls --enable-alias --with-curses \
		 || exit 1

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make || exit 1

# INSTALL...
	make DESTDIR=${INSTTEMP} install || exit 1
	( cd ${INSTTEMP}/bin && ln -sf bash sh ) || exit 1
}

make_tc_host()
{
# CONFIGURE...
	./configure --prefix=${INSTTEMP}/usr --bindir=${INSTTEMP}/bin \
	 || exit 1

# BUILD...
	make || exit 1

# INSTALL...
	make install || exit 1
	( cd ${INSTTEMP}/bin && ln -sf bash sh )
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac
