#!/bin/sh
# 27/06/2003

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
# - the provided Makefile expects the install tree to exist
	mkdir -p ${INSTTEMP}/usr/bin ${INSTTEMP}/usr/man/man1 || exit 1

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make CC=${TARGET_CPU}-uclibc-gcc || exit 1

# INSTALL...
	make PREFIX=${INSTTEMP}/usr install || exit 1
}

make_tc_host()
{
# CONFIGURE...
# - the provided Makefile expects the install tree to exist
	mkdir -p ${INSTTEMP}/usr/bin ${INSTTEMP}/usr/man/man1 || exit 1

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make CC=gcc || exit 1

# INSTALL...
	make PREFIX=${INSTTEMP}/usr install || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac
