#!/bin/sh -x
# 01/07/2003

#EXCLUDES="bin/bzless bin/bzmore bin/bzip2recover usr/bin/bzcmp usr/bin/bzdiff usr/bin/bzgrep usr/bin/bzegrep usr/bin/bzfgrep"

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

do_prelim()
{
	[ -r Makefile_libbz2_so.OLD ] || cp Makefile-libbz2_so Makefile-libbz2_so.OLD
	[ -r Makefile.OLD ] || cp Makefile Makefile.OLD

	cat Makefile-libbz2_so.OLD \
		| sed 's%=gcc%=$${CROSS}gcc%' \
		| sed 's%$(BIGFILES)%$(XCFLAGS)%' \
		> Makefile-libbz2_so
	cat Makefile.OLD \
		| sed 's%=gcc%=$${CROSS}gcc%' \
		| sed 's%=ar%=$${CROSS}ar%' \
		| sed 's%=ranlib%=$${CROSS}ranlib%' \
		| sed 's%$(BIGFILES)%$(XCFLAGS)%' \
		> Makefile
}

make_build()
{
# CONFIGURE...
	do_prelim

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make CROSS=${TARGET_CPU}-uclibc- XCFLAGS='' -f Makefile-libbz2_so || exit 1

# INSTALL...
# ...'make install' assumes the INSTTEMP hasn't been used before
	[ "`ls ${UTILS_INSTTEMP}/bin/bz* 2>/dev/null`" ] && rm -rf ${UTILS_INSTTEMP}/bin/bz*
	[ "`ls ${UTILS_INSTTEMP}/usr/bin/bz* 2>/dev/null`" ] && rm -rf ${UTILS_INSTTEMP}/usr/bin/bz*

	mkdir -p ${MINIMAL_INSTTEMP}/bin || exit 1
	mkdir -p ${MINIMAL_INSTTEMP}/usr/lib || exit 1
	mkdir -p ${MINIMAL_INSTTEMP}/usr/man/man1 || exit 1
	mkdir -p ${UTILS_INSTTEMP}/bin || exit 1

	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make CROSS=${TARGET_CPU}-uclibc- PREFIX=${UTILS_INSTTEMP}/usr install || exit 1

# ...updates
	cp bzip2-shared ${MINIMAL_INSTTEMP}/bin/bzip2 || exit 1
	( cd ${MINIMAL_INSTTEMP}/bin &&\
		ln -sf bzip2 bunzip2 &&\
		ln -sf bzip2 bzcat \
	) || exit 1

	cp libbz2.so.1.0.2 ${MINIMAL_INSTTEMP}/usr/lib/
	( cd ${MINIMAL_INSTTEMP}/usr/lib &&\
		ln -sf libbz2.so.1.0.2 libbz2.so.1.0 &&\
		ln -sf libbz2.so.1.0.2 libbz2.so \
	) || exit 1

	( cd ${MINIMAL_INSTTEMP}/usr && rm -rf include )
	( cd ${UTILS_INSTTEMP}/usr &&\
		rm -rf lib ;\
		mv include ${MINIMAL_INSTTEMP}/usr \
	)

	( cd ${UTILS_INSTTEMP}/bin && \
		ln -sf bzless bzmore \
	) || exit 1
	( cd ${UTILS_INSTTEMP}/usr/bin &&\
		rm bunzip2 bzcat bzip2 bzmore &&\
		mv bzip2recover bzless ../../bin &&\
		rm bzcmp &&\
		ln -sf bzdiff bzcmp &&\
		rm bzegrep bzfgrep &&\
		ln -sf bzgrep bzegrep &&\
		ln -sf bzgrep bzfgrep \
	) || exit 1

	( cd ${UTILS_INSTTEMP}/usr/man/man1 &&\
		mv bzip2.1 ${MINIMAL_INSTTEMP}/usr/man/man1/ &&\
		cd ${MINIMAL_INSTTEMP}/usr/man/man1 &&\
		echo '.so man1/bzip2.1' > bzunzip2.1 &&\
		echo '.so man1/bzip2.1' > bzcat.1 \
	) || exit 1
}

make_tc_host()
{
# CONFIGURE...
	do_prelim
	# fix the Makefile accordingly
	[ -r Makefile.OLD ] || cp Makefile Makefile.OLD
	cat Makefile.OLD \
		| sed 's/ln \$/ln -sf $/' \
		> Makefile

# BUILD...
	# NB! default 'make' invocation involves self-tests...
	make || exit 1

# INSTALL...
# ...'make install' assumes the INSTTEMP hasn't been used before
	[ "`ls ${INSTTEMP}/bin/bz* 2>/dev/null`" ] && rm -rf ${INSTTEMP}/bin/bz*
	[ "`ls ${INSTTEMP}/usr/bin/bz* 2>/dev/null`" ] && rm -rf ${INSTTEMP}/usr/bin/bz*
	mkdir -p ${INSTTEMP}/bin ${INSTTEMP}/lib || exit 1
	make PREFIX=${INSTTEMP}/usr install || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac
