#!/bin/sh
# 01/04/2003

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

do_prelim()
{
	[ -r Makefile_libbz2_so.OLD ] || cp Makefile-libbz2_so Makefile-libbz2_so.OLD
	[ -r Makefile.OLD ] || cp Makefile Makefile.OLD

	# 'make install' assumes the INSTTEMP hasn't been used before
	[ "`ls ${INSTTEMP}/bin/bz* 2>/dev/null`" ] && rm -rf ${INSTTEMP}/bin/bz*
	[ "`ls ${INSTTEMP}/usr/bin/bz* 2>/dev/null`" ] && rm -rf ${INSTTEMP}/usr/bin/bz*
	mkdir -p ${INSTTEMP}/bin ${INSTTEMP}/lib
}

make_build()
{
# CONFIGURE...
	do_prelim
	cat Makefile-libbz2_so.OLD \
		| sed 's%=gcc%=$${CROSS}gcc%' \
		| sed 's%$(BIGFILES)%$(XCFLAGS)%' \
		> Makefile-libbz2_so
	cat Makefile.OLD \
		| sed 's%=gcc%=$${CROSS}gcc%' \
		| sed 's%=ar%=$${CROSS}ar%' \
		| sed 's%=ranlib%=$${CROSS}ranlib%' \
		| sed 's%$(BIGFILES)%$(XCFLAGS)%' \
		> Makefile

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make CROSS=${TARGET_CPU}-uclibc- XCFLAGS='' -f Makefile-libbz2_so || exit 1

# INSTALL...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make CROSS=${TARGET_CPU}-uclibc- PREFIX=${INSTTEMP}/usr install || exit 1
	cp bzip2-shared ${INSTTEMP}/bin/bzip2 || exit 1
	ln -sf libbz2.so.1.0 libbz2.so
	cp -a libbz2.so* ${INSTTEMP}/lib || exit 1
	( cd ${INSTTEMP}/usr/lib && ln -sf ../../lib/libzz2.so )
	( cd ${INSTTEMP}/usr/bin &&\
		rm bunzip2 bzcat bzip2 bzmore &&\
		mv bzip2recover bzless ../../bin &&\
		rm bzcmp &&\
		ln -sf bzdiff bzcmp &&\
		rm bzegrep bzfgrep &&\
		ln -sf bzgrep bzegrep &&\
		ln -sf bzgrep bzfgrep \
	) || exit 1
	( cd ${INSTTEMP}/bin &&\
		ln -sf bzip2 bunzip2 &&\
		ln -sf bzip2 bzcat &&\
		ln -sf bzless bzmore \
	) || exit 1
}

make_tc_host()
{
	# fix the Makefile accordingly
	[ -r Makefile.OLD ] || cp Makefile Makefile.OLD
	cat Makefile.OLD \
		| sed 's/ln \$/ln -sf $/' \
		> Makefile

	# NB! default 'make' invocation involves self-tests...
	make || exit 1

	make PREFIX=${INSTTEMP}/usr install || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac
