#!/bin/sh
# 05/06/2003
# with inspiration from uClibc buildroot

#TODO: complains of missing structure members (eg. getdate compile)

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 utils_cv_sys_open_max=256 \
	 CC=${TARGET_CPU}-uclibc-gcc \
		./configure \
		 --prefix=/usr \
		 --build=`uname -m` --host=${TARGET_CPU} --target=${TARGET_CPU} \
		 --disable-largefile --disable-nls \
		 --disable-rpath --disable-dependency-tracking \
		 || exit 1

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make CC=${TARGET_CPU}-uclibc-gcc seq_LDADD="-lm -L../lib -lfetish"  || exit 1

# INSTALL...
	make prefix=${INSTTEMP}/usr install || exit 1
}

make_tc_host()
{
	./configure --prefix=${INSTTEMP}/usr || exit 1
	make || exit 1
	make prefix=${INSTTEMP}/usr install || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac
