#!/bin/sh
# 04/07/2003

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc \
		./configure \
		 --prefix=/usr \
		 --disable-nls || exit 1

# BUILD...
# `make` effects `make all` (libs, progs, docs)
# Since `make docs` REQUIRES makeinfo - run manually and let it fail
#	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
#		make
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make libs || exit 1
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make progs || exit 1
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make docs

# INSTALL...
# `make install` fails since we bypass making the documentation :(
#	make prefix=${INSTTEMP}/usr install || exit 1
	make prefix=${INSTTEMP}/usr install-libs-recursive || exit 1
	make prefix=${INSTTEMP}/usr install-progs-recursive || exit 1

	# `make install-libs` for e2fsprogs-devel
}

make_tc_cross()
{
# CONFIGURE...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc \
		./configure \
		 --prefix=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/usr \
		 --disable-nls || exit 1

# BUILD...
# `make` effects `make all` (libs, progs, docs)
# Since `make docs` REQUIRES makeinfo - run manually and let it fail
#	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
#		make
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make libs || exit 1
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make progs || exit 1
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make docs

# INSTALL...
# `make install` fails since we bypass making the documentation :(
#	make prefix=${INSTTEMP}/usr install || exit 1
	make install-libs-recursive || exit 1
	make install-progs-recursive || exit 1

	# `make install-libs` for e2fsprogs-devel
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-cross)
	INSTTEMP=${TCTREE} make_tc_cross || exit 1
	;;
*)
	exit 1
	;;
esac
