#!/bin/sh
# 30/06/2003

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc \
		./configure --prefix=/usr --bindir=/bin \
		 --host=`uname -m` --target=${TARGET_CPU} \
		 --disable-gettext \
		 || exit 1

	[ -r i18n.h ] && mv i18n.h i18n.h.OLD || exit 1
	cat i18n.h.OLD \
		| sed 's%gettext *(str)%(str) /* gettext(str) */%' \
		> i18n.h

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make CC=${TARGET_CPU}-uclibc-gcc || exit 1

# INSTALL...
	make DESTDIR=${INSTTEMP} install || exit 1
}

#make_toolchain()
#{
#	./configure --prefix=${INSTTEMP}/usr --bindir=${INSTTEMP}/bin || exit 1
#	make || exit 1
#	make install || exit 1
#}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
#toolchain)
#	INSTTEMP=${TCTREE} make_toolchain || exit 1
#	;;
*)
	exit 1
	;;
esac
