#!/bin/sh
# 06/06/2003

# TODO: Check out odd terminal behaviour (under chroot emulation anyway)

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc \
		./configure \
		 --prefix=/usr/local \
		 --with-x=no --libs="" \
		 `uname -s | tr 'A-Z' 'a-z'` \
		 || exit 1

# ...regenerate Makefile
	mv Makefile Makefile.OLD || exit 1
	cat Makefile.OLD \
		| sed 's/DIR=/DIR=${prefix}/' \
		| sed "s%^CFLAGS=%CFLAGS=\${FLAGI}${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/include/ncurses%" \
		> Makefile || exit 1

	[ -r insticon.sh.OLD ] || mv insticon.sh insticon.sh.OLD
	cat insticon.sh.OLD \
		| sed "s%xinc=/usr%xinc=${INSTTEMP}/usr%" \
		| sed "s%xlib=/usr%xlib=${INSTTEMP}/usr%" \
		> insticon.sh || exit 1

	[ -r instman.sh.OLD ] || mv instman.sh instman.sh.OLD
	cat instman.sh.OLD \
		| sed "s%/usr/man%${INSTTEMP}/usr/man%g" \
		> instman.sh || exit 1

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make || exit 1

# INSTALL...
	mkdir -p ${INSTTEMP}/usr/local/bin || exit 1
	mkdir -p ${INSTTEMP}/usr/man/man1 || exit 1
	make prefix=${INSTTEMP} install || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
#toolchain-host)
#	INSTTEMP=${TCTREE} make_tc_host || exit 1
#	;;
*)
	exit 1
	;;
esac
