#!/bin/sh
# 27/05/2003

# TODO:- willow claims undefined references to fputc*()

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_prelim()
{
	[ -r lib/nextelem.c.OLD ] \
		|| cp lib/nextelem.c lib/nextelem.c.OLD
	cp -f lib/nextelem.c.OLD lib/nextelem.c || exit 1
	cat <<"EOP" | patch -i - lib/nextelem.c
34a35
> #ifndef strstr
35a37
> #endif
EOP
	[ -r find/fstype.c.OLD ] \
		|| cp find/fstype.c find/fstype.c.OLD
	cp -f find/fstype.c.OLD find/fstype.c || exit 1
	cat <<"EOP" | patch -i - find/fstype.c
32a33
> #ifndef strstr
34a36
> #endif
EOP
	[ -r find/parser.c.OLD ] \
		|| cp find/parser.c find/parser.c.OLD
	cp -f find/parser.c.OLD find/parser.c || exit 1
	cat <<"EOP" | patch -i - find/parser.c
54a55
> #ifndef strstr
55a57
> #endif
EOP
	[ -r xargs/xargs.c.OLD ] \
		|| cp xargs/xargs.c xargs/xargs.c.OLD
	cp -f xargs/xargs.c.OLD xargs/xargs.c || exit 1
	cat <<"EOP" | patch -i - xargs/xargs.c
62a63
> #ifndef strstr
64a66
> #endif
EOP
}

make_build()
{
# CONFIGURE...
	make_prelim
# presumably uClibc fakes '_GNU_SOURCE' internally to make some
# things work. Unfortunately it breaks the introduction of
# the FNM_CASEFOLD definition via lib/fnmatch.h...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc \
	 CPPFLAGS="-D_POSIX_C_SOURCE=1 -Dre_max_failures=re_max_failures2" \
	 ac_cv_func_setvbuf_reversed=no \
	 ac_cv_func_closedir_void=no \
		./configure --prefix=/usr \
		 --build=`uname -m` --host=${TARGET_CPU} \
		 --disable-nls \
		 || exit 1

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make || exit 1

# INSTALL...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make prefix=${INSTTEMP}/usr install || exit 1
	[ -r ${INSTTEMP}/usr/bin/find ] || exit 1
}

make_tc_host()
{
# CONFIGURE...
	make_prelim
	CPPFLAGS="-D_POSIX_C_SOURCE=1 -Dre_max_failures=re_max_failures2" \
		./configure --prefix=${INSTTEMP}/usr || exit 1

# BUILD...
	make || exit 1

# INSTALL...
	make install || exit 1
	[ -r ${INSTTEMP}/usr/bin/find ] || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac
