#!/bin/sh -x
# 04/07/2003

#TODO: build fails with undefined references from putc() macros

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc \
		./configure \
		  --prefix=/usr \
		 --build=`uname -m` --host=${TARGET_CPU} --target=${TARGET_CPU} \
		 --disable-nls \
		 || exit 1

# ...stop it using ${prefix}/usr/include - this is the host kernel,
# not the cross-build target one!
	mv Makefile Makefile.OLD || exit 1
	cat Makefile.OLD \
		| sed "s%-I.*/include%%" \
		| sed "s% -I. -I%-nostdinc -I${TCTREE}/usr/include -I${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/include -I${TCTREE}/usr/lib/gcc-lib/i686-linux/2.95.3/include/ -I%" \
		> Makefile

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make all \
		 || exit1

# INSTALL...
	make DESTDIR=${INSTTEMP} install || exit 1
	( cd ${INSTTEMP}/usr/bin && ( \
		[ -r lex ] && rm lex ;\
		grep '^#lex#.' $0 | sed 's/......//' > lex ;\
		chmod a+rx lex \
	) || exit 1 ) || exit 1
}

make_tc_host()
{
# CONFIGURE...
	./configure --prefix=${INSTTEMP}/usr || exit 1

# BUILD...
	make || exit 1

# INSTALL...
	make DESTDIR=/ install || exit 1
	( cd ${INSTTEMP}/usr/bin && ( \
		[ -r lex ] && rm lex ;\
		grep '^#lex#.' $0 | sed 's/......//' > lex ;\
		chmod a+rx lex \
	) || exit 1 ) || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac

#lex#	#!/bin/sh
#lex#	# Begin /usr/bin/lex
#lex#	
#lex#	exec /usr/bin/flex -l "$@"
#lex#	
#lex#	# End /usr/bin/lex
