#!/bin/sh
# 25/05/2003

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

#X#	distro-cross:

make_build()
{
# CONFIGURE...
	[ -r Makefile.in.backup ] || cp awklib/Makefile.in awklib/Makefile.in.backup
	sed	-e '/^datadir/s/awk/gawk/' \
		-e '/^libexecdir/s%/awk%%' awklib/Makefile.in.backup \
		> awklib/Makefile.in
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc \
	 ac_cv_func_getpgrp_void=yes \
		./configure --prefix=/usr --libexecdir=/usr/bin \
		 --disable-nls \
		 --host=`uname -m` --build=${TARGET_CPU} \
		 || exit 1

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make || exit 1

# INSTALL...
	make DESTDIR=${INSTTEMP} install || exit 1
	( cd ${INSTTEMP}/usr/bin && ( \
		rm *gawk-* ;\
		ln -sf gawk awk \
	) || exit 1 ) || exit 1
}

make_tc_host()
{
# CONFIGURE...
	[ -r Makefile.in.backup ] || cp awklib/Makefile.in awklib/Makefile.in.backup
	sed	-e '/^datadir/s/awk/gawk/' \
		-e '/^libexecdir/s%/awk%%' awklib/Makefile.in.backup \
		> awklib/Makefile.in
	./configure --prefix=${INSTTEMP}/usr --libexecdir=${INSTTEMP}/usr/bin \
	   --disable-nls \
	   --build=`uname -m` \
	   || exit 1

# BUILD...
	make || exit 1

# INSTALL...
	make install || exit 1
	( cd ${INSTTEMP}/usr/bin && ( \
		rm *gawk-* ;\
		ln -sf gawk awk \
	) || exit 1 ) || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac
