#!/bin/sh
# 10/05/2003

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
	mkdir -p ${SOURCETMP}/gcc-build
	( cd ${SOURCETMP}/gcc-build && \
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${CROSS_PREFIX}-gcc \
		${SOURCETMP}/${SRCXPATH}/configure \
		 --prefix=${INSTTEMP}/usr \
		 --enable-languages=c,c++ \
		 --host=`uname -m`-linux --build=${TARGET_ARCH} \
		 --disable-nls --disable-largefile \
			|| exit 1 ;\
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${CROSS_PREFIX}-gcc \
		make bootstrap || exit 1 ;\
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${CROSS_PREFIX}-gcc \
		make || exit 1 ;\
		make install || exit 1 \
	) || exit 1
}

make_tc_host()
{
	mkdir -p ${SOURCETMP}/gcc-build
	( cd ${SOURCETMP}/gcc-build && \
		${SOURCETMP}/${SRCXPATH}/configure \
		 --prefix=${INSTTEMP}/usr \
		 --enable-languages=c,c++ \
		 --disable-nls --disable-largefile \
			|| exit 1 ;\
		make bootstrap || exit 1 ;\
		make || exit 1 ;\
		make install || exit 1 \
	) || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac
