#!/bin/sh
# 18/06/2003

# TODO:- Fails to link with gettext (of which no support-lib version)

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc CCC=${TARGET_CPU}-uclibc-g++ \
		./configure --prefix=/usr \
		 --host=`uname -m` --target=${TARGET_CPU}-uclibc \
		 --disable-largefile \
		 || exit 1

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make || exit 1

# INSTALL...
	mkdir -p ${INSTTEMP}/usr
	make prefix=${INSTTEMP}/usr install || exit 1
}

make_tc_host()
{
# CONFIGURE...
	./configure --prefix=/usr \
		 --host=`uname -m` --target=${TARGET_CPU}-uclibc \
		 --disable-largefile \
		 || exit 1

# BUILD...
	make || exit 1

# INSTALL...
	mkdir -p ${INSTTEMP}/usr
	make prefix=${INSTTEMP}/usr install || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac
