#!/bin/sh
# 05/07/2003

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc \
		./configure --prefix=/usr \
		 --host=`uname -m` --target=${TARGET_CPU} \
		 --disable-largefile --disable-nls || exit 1

	[ -r src/gpm.c.OLD ] || mv src/gpm.c src/gpm.c.OLD || exit 1
	cat src/gpm.c.OLD \
		| sed 's/size_t len;/time_t staletime; size_t len;/' \
		> src/gpm.c || exit 1

	[ -r Makefile.include.OLD ] \
		|| mv Makefile.include Makefile.include.OLD || exit 1
	cat Makefile.include.OLD \
		| sed 's/no .*/no/' \
		> Makefile.include

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make LDFLAGS=-lm || exit 1

# INSTALL...
	make ROOT=${INSTTEMP} install || exit 1
}

#make_tc_host()
#{
#	## tries to use 'cc' by default. Assume cc != gcc:
#	CC=`which gcc` ./configure --prefix=${INSTTEMP}/usr \
#		--bindir=/bin \
#		--libexecdir=/usr/bin \
#		--disable-largefile --disable-nls || exit 1
#	make || exit 1
#	make prefix=${INSTTEMP}/usr bindir=${INSTTEMP}/bin libexecdir=${INSTTEMP}/usr/bin install || exit 1
#}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
#toolchain-host)
#	INSTTEMP=${TCTREE} make_tc_host || exit 1
#	;;
*)
	exit 1
	;;
esac
