#!/bin/sh
# 25/06/2003

#TODO: (runtime) "Error opening terminal: screen"

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	[ -r grub/asmstub.c.OLD ] || cp grub/asmstub.c grub/asmstub.c.OLD
	cat grub/asmstub.c.OLD \
		| sed 's/define _FILE_OFFSET_BITS.*/define _FILE_OFFSET_BITS 32/' \
		| sed 's/define _LARGEFILE_SOURCE.*/define _LARGEFILE_SOURCE 0/' \
		> grub/asmstub.c

	[ -r lib/device.c.OLD ] || cp lib/device.c lib/device.c.OLD
	cat lib/device.c.OLD \
		| sed 's/define _FILE_OFFSET_BITS.*/define _FILE_OFFSET_BITS 32/' \
		| sed 's/define _LARGEFILE_SOURCE.*/define _LARGEFILE_SOURCE 0/' \
		> lib/device.c

	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc \
		./configure --prefix=/usr \
		 --build=`uname -m` --host=${TARGET_CPU} --target=${TARGET_CPU} \
		 --disable-largefile --disable-nls \
		 || exit 1

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make || exit 1

# INSTALL...
	make prefix=${INSTTEMP}/usr install || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
#toolchain-host)
#	INSTTEMP=${TCTREE} make_tc_host || exit 1
#	;;
*)
	exit 1
	;;
esac
