#!/bin/sh
# 05/06/2003

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

do_prelim()
{
	mkdir -p ${INSTTEMP}/bin ${INSTTEMP}/usr/bin
}

make_build()
{
# CONFIGURE...
	do_prelim
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc CFLAGS=-O2 \
		./configure --prefix=/
	if [ ! -r gzexe.in.OLD ] ; then \
		cp gzexe.in gzexe.in.OLD ;\
		sed 's%"BINDIR"%/bin%' gzexe.in.OLD > gzexe.in ;\
	fi

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make

# INSTALL...
	make prefix=${INSTTEMP} install
	( cd ${INSTTEMP}/bin && ( \
		[ -r gunzip ] && rm gunzip ;\
		ln -s gzip gunzip ;\
		[ -r zcat ] && rm zcat ;\
		ln -s gzip zcat ;\
		[ -r zdiff ] && rm zdiff ;\
		ln -s zcmp zdiff ;\
		for FILE in znew zmore zgrep zforce zdiff zcmp gzexe ; do \
			[ -r ../usr/bin/$FILE ] && rm ../usr/bin/$FILE ;\
			mv $FILE ../usr/bin/ ;\
		done
	) || exit 1 ) || exit 1
}

make_tc_host()
{
# CONFIGURE...
	do_prelim
	./configure --prefix=${INSTTEMP}/ || exit 1
	if [ ! -r gzexe.in.OLD ] ; then \
		cp gzexe.in gzexe.in.OLD ;\
		sed 's%"BINDIR"%/bin%' gzexe.in.OLD > gzexe.in ;\
	fi

# BUILD...
	make || exit 1

# INSTALL...
	make install || exit 1
	( cd ${INSTTEMP}/bin && ( \
		[ -r gunzip ] && rm gunzip ;\
		ln -s gzip gunzip ;\
		[ -r zcat ] && rm zcat ;\
		ln -s gzip zcat ;\
		[ -r zdiff ] && rm zdiff ;\
		ln -s zcmp zdiff ;\
		for FILE in znew zmore zgrep zforce zdiff zcmp gzexe ; do \
			[ -r ../usr/bin/$FILE ] && rm ../usr/bin/$FILE ;\
			mv $FILE ../usr/bin/ ;\
		done
	) || exit 1 ) || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac
