#!/bin/sh -x
# 01/07/2003

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
# ...configure is a simplified workalike
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc CFLAGS=-O2 \
		./configure --prefix=/usr || exit 1

	[ -r gzexe.in.OLD ] || mv gzexe.in gzexe.in.OLD || exit 1
	cat gzexe.in.OLD \
		| sed 's%"BINDIR"%/bin%' \
		> gzexe.in || exit 1

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make || exit 1

# INSTALL...
	mkdir -p ${UTILS_INSTTEMP}/usr/bin || exit 1
	make prefix=${UTILS_INSTTEMP}/usr install || exit 1

	mkdir -p ${MINIMAL_INSTTEMP}/bin || exit 1
	( cd ${UTILS_INSTTEMP}/usr/bin &&
		mv gzip ${MINIMAL_INSTTEMP}/bin
		[ -r gunzip ] && rm gunzip
		[ -r zcat ] && rm zcat
		[ -r zdiff ] && rm zdiff
		ln -sf zcmp zdiff
	) || exit 1
	( cd ${MINIMAL_INSTTEMP}/bin &&
		ln -sf gzip gunzip
		ln -sf gzip zcat
	) || exit 1

	mkdir -p ${MINIMAL_INSTTEMP}/usr/man/man1 || exit 1
	( cd ${UTILS_INSTTEMP}/usr/man/man1 &&
		for M in gunzip.1 gzip.1 zcat.1 ; do
			mv $M ${MINIMAL_INSTTEMP}/usr/man/man1/$M || exit 1
		done || exit 1
	) || exit 1

	( cd ${MINIMAL_INSTTEMP}/usr && rm -rf info )
	mv ${UTILS_INSTTEMP}/usr/info/ ${MINIMAL_INSTTEMP}/usr || exit 1
}

make_tc_host()
{
# CONFIGURE...
	./configure --prefix=${INSTTEMP}/ || exit 1
	if [ ! -r gzexe.in.OLD ] ; then \
		cp gzexe.in gzexe.in.OLD ;\
		sed 's%"BINDIR"%/bin%' gzexe.in.OLD > gzexe.in ;\
	fi

# BUILD...
	make || exit 1

# INSTALL...
	make install || exit 1
	( cd ${INSTTEMP}/bin && ( \
		[ -r gunzip ] && rm gunzip ;\
		ln -sf gzip gunzip ;\
		[ -r zcat ] && rm zcat ;\
		ln -sf gzip zcat ;\
		[ -r zdiff ] && rm zdiff ;\
		ln -sf zcmp zdiff ;\
		for FILE in znew zmore zgrep zforce zdiff zcmp gzexe ; do \
			[ -r ../usr/bin/$FILE ] && rm ../usr/bin/$FILE ;\
			mv $FILE ../usr/bin/ ;\
		done
	) || exit 1 ) || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac
