#!/bin/sh
# 26/06/2003

#TODO: rejects that we configure with '--enable-shared'

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc \
		./configure \
		 --build=`uname -m` --host=${TARGET_CPU} --target=${TARGET_CPU} \
		 --prefix=/usr \
		 --enable-shared \
		 --disable-nls --disable-largefile \
		 || exit 1

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make || exit 1

# INSTALL...
	make prefix=${INSTTEMP}/usr install || exit 1
}

make_tc_target()
{
# CONFIGURE...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc \
		./configure \
		 --build=`uname -m` --host=${TARGET_CPU} --target=${TARGET_CPU} \
		 --prefix=/usr \
		 --enable-shared \
		 --disable-nls --disable-largefile \
		 || exit 1

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make || exit 1

# INSTALL...
	make prefix=${TCTREE}/usr/i386-linux-uclibc install || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-cross)
	INSTTEMP=${TCTREE} make_tc_target || exit 1
	;;
*)
	exit 1
	;;
esac
