#!/bin/sh
# 16/06/2003

#TODO: "cannot determine linux version when cross-compiling"

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc \
	  ac_cv_linux_vers=`uname -r ; uname -r 2>&1 | sed -n -e '/.* //' -e '/\..*//p'` \
		./configure --prefix=/usr \
		 --host=`uname -m` --target=${TARGET_CPU} \
		 --with-pcap=linux \
		 || exit 1

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make || exit 1

# INSTALL...
	make DESTDIR=${INSTTEMP} install || exit 1
}

make_tc_host()
{
	./configure --prefix=${INSTTEMP}/usr \
		|| exit 1
	make || exit 1
	make install || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac
