#!/bin/sh
# 12/06/2003

# NB: - requires 'bin86' in the toolchain

# TODO: - `make install` isn't supposed to do tests - but it does

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	[ -r Makefile.OLD ] || mv Makefile Makefile.OLD
	cat Makefile.OLD \
		| sed 's/^CC=cc$/CC=${CROSS}cc/' \
		> Makefile

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make CROSS=${TARGET_CPU}-uclibc-g all || exit 1

# INSTALL...
#	make ROOT=${INSTTEMP} install || exit 1
	mkdir -p ${INSTTEMP} || exit 1

	BUILTIN=1
	if [ ! -d ${INSTTEMP}/sbin ]; then mkdir ${INSTTEMP}/sbin; fi
	if [ ! -d ${INSTTEMP}/etc ]; then mkdir ${INSTTEMP}/etc; fi
	if [ ! -d ${INSTTEMP}/boot ]; then mkdir ${INSTTEMP}/boot; fi
	if [ ! -d ${INSTTEMP}/usr/sbin ]; then \
	  mkdir -p ${INSTTEMP}/usr/sbin; fi
	if [ ! -d ${INSTTEMP}/man ]; then mkdir ${INSTTEMP}/man; fi  
	if [ ! -d ${INSTTEMP}/man/man5 ]; then \
	  mkdir ${INSTTEMP}/man/man5; fi  
	if [ ! -d ${INSTTEMP}/man/man8 ]; then \
	  mkdir ${INSTTEMP}/man/man8; fi  
	if [ -f diag1.img ]; then \
	  cp -f diag1.img ${INSTTEMP}/boot; fi
	if [ -f diag2.img ]; then \
	  cp -f diag2.img ${INSTTEMP}/boot; fi
	if [ ! -L ${INSTTEMP}/boot/boot.b -a -f ${INSTTEMP}/boot/boot.b ]; then \
	  mv ${INSTTEMP}/boot/boot.b ${INSTTEMP}/boot/boot.old; fi
	if [ -f ${INSTTEMP}/boot/boot-bmp.b ]; then \
	  mv ${INSTTEMP}/boot/boot-bmp.b ${INSTTEMP}/boot/boot-bmp.old; fi
	if [ -f ${INSTTEMP}/boot/boot-menu.b ]; then \
	  mv ${INSTTEMP}/boot/boot-menu.b ${INSTTEMP}/boot/boot-menu.old; fi
	if [ -f ${INSTTEMP}/boot/boot-text.b ]; then \
	  mv ${INSTTEMP}/boot/boot-text.b ${INSTTEMP}/boot/boot-text.old; fi
	if [ -f ${INSTTEMP}/boot/chain.b ]; then \
	  mv ${INSTTEMP}/boot/chain.b ${INSTTEMP}/boot/chain.old; fi
	if [ -f ${INSTTEMP}/boot/os2_d.b ]; then \
	  mv ${INSTTEMP}/boot/os2_d.b ${INSTTEMP}/boot/os2_d.old; fi
	if [ -f ${INSTTEMP}/boot/mbr.b ]; then \
	  mv ${INSTTEMP}/boot/mbr.b ${INSTTEMP}/boot/mbr.old; fi
	if [ -f os2_d.b  -a  ${BUILTIN} = 0 ]; then \
	  cp os2_d.b ${INSTTEMP}/boot; fi
	if [ ${BUILTIN} = 0 ]; then \
	  cp boot-text.b boot-menu.b boot-bmp.b chain.b mbr.b ${INSTTEMP}/boot; fi
	if [ ! -L ${INSTTEMP}/boot/boot.b  -a  ${BUILTIN} = 0 ]; then \
	  ln -s boot-menu.b ${INSTTEMP}/boot/boot.b; fi
	if [ ${BUILTIN} = 1 ]; then \
	  rm -f ${INSTTEMP}/boot/boot.b; fi
	cp mkrescue ${INSTTEMP}/sbin
	cp lilo ${INSTTEMP}/sbin
	strip ${INSTTEMP}/sbin/lilo
	cp keytab-lilo.pl ${INSTTEMP}/usr/sbin
	cp manPages/lilo.8 ${INSTTEMP}/man/man8
	cp manPages/mkrescue.8 ${INSTTEMP}/man/man8
	cp manPages/lilo.conf.5 ${INSTTEMP}/man/man5
	if [ -e ${INSTTEMP}/etc/lilo/install ]; then echo; \
	  echo -n "${INSTTEMP}/etc/lilo/install is obsolete. LILO is now ";\
	  echo "re-installed "; \
	  echo "by just invoking /sbin/lilo"; echo; fi
	echo "/sbin/lilo must now be run to complete the update."
}

#make_tc_host()
#{
#	./configure --prefix=${INSTTEMP}/usr || exit 1
#	make || exit 1
#	make prefix=${INSTTEMP}/usr install || exit 1
#}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
#toolchain-host)
#	INSTTEMP=${TCTREE} make_tc_host || exit 1
#	;;
*)
	exit 1
	;;
esac
