#!/bin/sh
# 27/03/2003

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_tc_host()
{
	make mrproper || exit 1
	make include/linux/version.h || exit 1
	make symlinks || exit 1
	
	if [ -z "$TARGET_CPU" ] ; then
		echo "*** WARNING: Determining TARGET_CPU"
		TARGET_CPU=`ls -l include/asm | sed 's/.*-//'`
	fi
	cat arch/${TARGET_CPU}/defconfig \
		| sed 's%#* *CONFIG_PARIDE_PCD[= ].*%##CONFIG_PARIDE_PCD: %' \
		| sed 's%#* *CONFIG_PARIDE_PT[= ].*%##CONFIG_PARIDE_PT: %' \
		| sed 's%#* *CONFIG_AFFS_FS[= ].*%##CONFIG_AFFS_FS: %' \
		> .config
	echo "CONFIG_PARIDE_PCD=y" >> .config
	echo "CONFIG_PARIDE_PT=y" >> .config
	echo "CONFIG_AFFS_FS=y" >> .config
	
	if [ -z "${INSTTEMP}" ] ; then
		echo "$0: INSTTEMP not set"
	else
		[ "${PKGNAME}" ] || exit 1
		if [ "${PATCHVER}" ] ; then
			INSTPATH=linux-${PATCHVER}
		else
			[ "${PKGVER}" ] || exit 1
			INSTPATH=linux-${PKGVER}
		fi
		mkdir -p ${INSTTEMP}/usr/src/${INSTPATH}
	
		echo "*** pwd" `pwd`
		tar cvf - .config * | ( cd ${INSTTEMP}/usr/src && \
			( cd ${INSTPATH} && tar xvf - ) ;\
			ln -sf ${INSTPATH} linux || exit 1 \
			) || exit 1
	
		mkdir -p ${INSTTEMP}/usr/include/asm || rm -rf ${INSTTEMP}/usr/include/asm/*
	
		cp include/asm/* ${INSTTEMP}/usr/include/asm
		cp -R include/linux ${INSTTEMP}/usr/include
	
##	-- some kernel header files include autoconf.h regardless of
##	-- whether we're building a kernel at the time or not :(
		touch ${INSTTEMP}/usr/include/linux/autoconf.h
		touch ${INSTTEMP}/usr/src/linux/include/linux/autoconf.h
	fi
}

case "$1" in
#distro-cross)
#	make_build || exit 1
#	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac
