#!/bin/sh
# 08/06/2003

# TODO:- REALLY needs bash - eg. module symlinks, some 'gcc -D' config
# TODO:- Want no APM *AT ALL* for kernel to work on bochs
# TODO:- Need /sbin/genksyms (where from?) to get kernel module symbols

# NB: - Need EXPERIMENTAL stuff for the kernel automounter, or only
# NB: get to use minix fs (or presumably the first-selected fs)

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_tc_host()
{
# PREPARE...
	[ -r Makefile.OLD ] || cp Makefile Makefile.OLD
#	2.0.40-rc6 patch still thinks it's 2.0.40-rc5
	sed 's/^EXTRAVERSION.*rc5/EXTRAVERSION=-rc6/' Makefile.OLD > Makefile

	make mrproper || exit 1
	make include/linux/version.h || exit 1
	make symlinks || exit 1
	
	if [ -z "$TARGET_CPU" ] ; then
		echo "*** WARNING: Determining TARGET_CPU"
		TARGET_CPU=`ls -l include/asm | sed 's/.*-//'`
	fi

# CONFIGURE...
	cp arch/${TARGET_CPU}/defconfig .config
	#yes "" | make config
	for CFG in \
		"EXPERIMENTAL y" \
		"MODULES y" "MODVERSIONS unset" "KERNELD y" \
		"MATH_EMULATION y" \
		"MEM_STD y" "MEM_ENT unset" "MEM_SPECIAL unset" \
		"MAX_MEMSIZE 1024" \
		"NET y" "MAX_16M unset" "PCI y" "SYSVIPC unset" \
		"BINFMT_AOUT y" "BINFMT_ELF y" "KERNEL_ELF y" \
			"BINFMT_JAVA unset" \
		"M386 y" "M486 unset" "M586 unset" "M686 unset" \
		"APM y" "APM_CPU_IDLE y" \
			"APM_IGNORE_USER_SUSPEND unset" \
			"APM_DO_ENABLE unset" \
			"APM_DISPLAY_BLANK y" "APM_POWER_OFF y" \
			"APM_IGNORE_MULTIPLE_SUSPEND unset" \
		"BLK_DEV_FD y" "BLK_DEV_IDE y" \
		"BLK_DEV_HD_IDE unset" "BLK_DEV_IDECD y" \
		"BLK_DEV_IDETAPE unset" "BLK_DEV_IDEFLOPPY unset" \
		"BLK_DEV_IDESCSI unset" "BLK_DEV_IDE_PCMCIA y" \
		"BLK_DEV_CMD640 y" "BLK_DEV_CMD640_ENHANCED unset" \
		"BLK_DEV_RZ1000 y" "BLK_DEV_TRITON y" \
		"BLK_DEV_OFFBOARD unset" "IDE_CHIPSETS unset" \
		"BLK_DEV_LOOP m" \
		"BLK_DEV_MD y" "MD_LINEAR m" "MD_STRIPED m" \
			"MD_MIRRORING m" "MD_RAID5 m" \
		"BLK_DEV_RAM y" "BLK_DEV_INITRD y" \
		"BLK_DEV_XD unset" \
		"BLK_DEV_DAC960 unset" "BLK_CPQ_DA unset" \
		"PARIDE m" "PARIDE_PD m" "PARIDE_PCD m" "PARIDE_PF m" \
			"PARIDE_PT m" "PARIDE_PG m" \
			"PARIDE_ATEN unset" "PARIDE_BPCK m" \
			"PARIDE_COMM unset" "PARIDE_DSTR unset" \
			"PARIDE_FIT2 unset" "PARIDE_FIT3 unset" \
			"PARIDE_EPAT unset" "PARIDE_EPIA unset" \
			"PARIDE_FRIQ unset" "PARIDE_FRPW unset" \
			"PARIDE_KBIC unset" "PARIDE_KTTI unset" \
			"PARIDE_ON20 unset" "PARIDE_ON26 unset" \
		"BLK_DEV_HD unset" \
		"FIREWALL unset" "BRIDGE unset" "NET_ALIAS unset" "INET y" \
		"IP_FORWARD unset" "IP_MULTICAST unset" \
		"SYN_COOKIES unset" "IP_ACCT unset" "IP_ROUTER unset" \
		"NET_IPIP unset" "INET_PCTCP unset" "INET_RARP unset" \
		"NO_PATH_MTU_DISCOVERY unset" \
		"IP_NOSR y" "SKB_LARGE y" \
		"IPX unset" "ATALK unset" "AX25 unset" "NETLINK unset" \
		"SCSI m" "BLK_DEV_SD m" "CHR_DEV_ST m" \
			"BLK_DEV_SR m" "CHR_DEV_SG m" \
			"SCSI_MULTI_LUN y" "SCSI_CONSTANTS unset" \
			"SCSI_7000FASST unset" "SCSI_ACARD unset" \
			"SCSI_AHA152X unset" "SCSI_AHA1542 unset" \
			"SCSI_AHA1740 unset" "SCSI_AIC7XXX unset" \
			"SCSI_ADVANSYS m" "SCSI_IN2000 unset" \
			"SCSI_AM53C974 unset" "SCSI_MEGARAID unset" \
			"SCSI_BUSLOGIC unset" "SCSI_DTC3280 unset" \
			"SCSI_EATA_DMA unset" "SCSI_EATA_PIO unset" \
			"SCSI_EATA unset" "SCSI_FUTURE_DOMAIN unset" \
			"SCSI_GENERIC_NCR5380 unset" \
			"SCSI_INITIO unset" "SCSI_INIA100 unset" \
			"SCSI_NCR53C406A unset" "SCSI_SYM53C416 unset" \
			"SCSI_NCR53C7xx unset" "SCSI_NCR53C8XX unset" \
			"SCSI_PPA m" "SCSI_PPA_HAVE_PEDANTIC y" \
			"SCSI_PAS16 unset" "SCSI_PCI2000 unset" \
			"SCSI_PCI2220I unset" "SCSI_PSI240I unset" \
			"SCSI_QLOGIC_FAS unset" \
			"SCSI_QLOGIC_ISP unset" \
			"SCSI_SEAGATE unset" "SCSI_DC390T unset" \
			"SCSI_T128 unset" "SCSI_TC2550 unset" \
			"SCSI_U14_34F unset" "SCSI_ULTRASTOR unset" \
			"SCSI_GDTH unset" \
		"NETDEVICES y" "DUMMY m" \
			"EQUALIZER unset" "PLIP unset" "PPP unset" \
			"SLIP unset" "NET_RADIO unset" \
		"NET_ETHERNET y" \
			"NET_VENDOR_3COM y" \
			"EL1 unset" "EL2 unset" "EL3 m" \
			"EL16 unset" "ELPLUS unset" \
			"3C515 unset" "VORTEX m" "NET_VENDOR_SMC unset" \
		"NET_PCI y" "PCNET32 unset" \
			"EEXPRESS_PRO m" \
			"EEXPRESS_PRO100B m" "DE4X5 unset" \
			"DEC_ELCP unset" "DGRS unset" "NE2K_PCI m" \
			"YELLOWFIN unset" "RTL8139 m" "EPIC unset" \
			"TLAN unset" "VIA_RHINE unset" "SHAPER unset" \
			"ETH16I unset" "FMV18X unset" "ISI unset" \
			"NI52 unset" "NI65 unset" "PCI_OPTIMIZE unset" \
		"NET_ISA y" \
			"LANCE unset" "AT1700 unset" "E2100 unset" \
			"DEPCA unset" "EWRK3 unset" "EEXPRESS m" \
			"HPLAN_PLUS unset" "HPLAN unset" "HP100 unset" \
			"NE2000 m" "SK_G16 unset" \
		"NET_EISA unset" "NET_POCKET unset" "TR unset" \
			"FDDI unset" "ARCNET unset" \
		"ISDN unset" "CD_NO_IDESCSI unset" \
		"QUOTA unset" "AUTOFS_FS y" \
			"MINIX_FS y" "EXT_FS unset" "EXT2_FS m" \
			"XIA_FS unset" \
			"NLS y"	"NLS_CODEPAGE_437 m" \
				"NLS_ISO8859_1 m" \
				"NLS_ISO8859_14 m" \
				"NLS_ISO8859_15 m" \
			"ISO9660_FS m" "FAT_FS y" "MSDOS_FS y" \
			"UMSDOS_FS y" "VFAT_FS y" \
		"PROC_FS y" "NFS_FS m" "SMB_FS m" "SMB_WIN95 y" \
		"HPFS_FS m" "SYSV_FS m" \
		"UFS_FS m" "BSD_DISKLABEL y" "SMD_DISKLABEL y" \
			"AFFS_FS m" "AMIGA_PARTITION y" \
		"SERIAL m" "SERIAL_PCI unset" "DIGI unset" "CYCLADES unset" \
			"STALDRV unset" "RISCOM8 unset" \
		"PRINTER m" "SPECIALIX unset" \
		"MOUSE y" \
			"ATIXL_BUSMOUSE m" "BUSMOUSE m" \
			"MS_BUSMOUSE m" "PSMOUSE m" "82C710_MOUSE y" \
		"UMISC unset" "QIC02_TAPE unset" "FTAPE m" \
		"WATCHDOG unset" "RTC unset" \
		"SOUND m" "PAS unset" "SB y" "ADLIB unset" \
			"MPU401 unset" "UART6850 unset" "PSS unset" \
			"GUS unset" "GUS16 unset" "GUSMAX unset" "MSS unset" \
			"SSCAPE unset" "TRIX unset" "MAD16 unset" \
			"CS4232 unset" "MAUI unset" \
		"AUDIO y" "MIDI y" "YM3812 Y" \
		"SBC_BASE 220" "SBC_IRQ 7" "SBC_DMA 1" "SB_DMA2 5" \
			"SB_MPU_BASE 0" "SB_MPU_IRQ -1" \
			"DSP_BUFFSIZE 65536" "LOWLEVEL_SOUND unset" \
		"PROFILE unset" "SADISTIC_KMALLOC unset" "SKB_CHECK unset" ; do
		set -- ${CFG}
		NAME=$1
		VALUE=$2
		cat .config \
			| sed "s%#* *CONFIG_${NAME}[= ].*%#[CONFIG_${NAME} adjusted]%" \
			> tmp.$$
		mv tmp.$$ .config
		case ${VALUE} in
		#*)	;;	## ...ignore
		unset|UNSET)	echo "# CONFIG_${NAME} is not set" >> .config ;;
		*)	echo "CONFIG_${NAME}=${VALUE}" >> .config ;;
		esac
	done
	cp .config config-apm || exit 1
	grep -v _APM[_=] config-apm > config-noapm
	cp config-noapm .config || exit 1

	if [ -z "${INSTTEMP}" ] ; then
		echo "$0: INSTTEMP not set"
	else
		[ "${PKGNAME}" ] || exit 1
		if [ "${PATCHVER}" ] ; then
			INSTPATH=linux-${PATCHVER}
		else
			[ "${PKGVER}" ] || exit 1
			INSTPATH=linux-${PKGVER}
		fi
		mkdir -p ${INSTTEMP}/usr/src/${INSTPATH}
	
		echo "*** pwd" `pwd`
		tar cvf - .config * | ( cd ${INSTTEMP}/usr/src && \
			( cd ${INSTPATH} && tar xvf - ) ;\
			ln -sf ${INSTPATH} linux || exit 1 \
			) || exit 1
	
		mkdir -p ${INSTTEMP}/usr/include/asm || rm -rf ${INSTTEMP}/usr/include/asm/*
	
		cp include/asm/* ${INSTTEMP}/usr/include/asm
		cp -R include/linux ${INSTTEMP}/usr/include
	
##	-- some kernel header files include autoconf.h regardless of
##	-- whether we're building a kernel at the time or not :(
		touch ${INSTTEMP}/usr/include/linux/autoconf.h
		touch ${INSTTEMP}/usr/src/linux/include/linux/autoconf.h
	fi

#	make dep modules modules_install bzImage install
}

case "$1" in
#distro-cross)
#	make_build || exit 1
#	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac
# 8390.o -> ../drivers/net/8390.o
# advansys.o -> ../drivers/scsi/advansys.o
# atixlmouse.o -> ../drivers/char/atixlmouse.o
# bpck.o -> ../drivers/block/paride/bpck.o
# busmouse.o -> ../drivers/char/busmouse.o
# dummy.o -> ../drivers/net/dummy.o
# eepro100.o -> ../drivers/net/eepro100.o
# eexpress.o -> ../drivers/net/eexpress.o
# ext2.o -> ../drivers/ext2.o
# ftape.o -> ../drivers/char/ftape/ftape.o
# hpfs.o -> ../drivers/hpfs.o
# ipv4.o -> ../drivers/net/ipv4.o
# isofs.o -> ../drivers/isofs.o
# linear.o -> ../drivers/block/linear.o
# loop.o -> ../drivers/block/loop.o
# lp.o -> ../drivers/char/lp.o
# misc.o -> ../drivers/char/misc.o
# msbusmouse.o -> ../drivers/char/msbusmouse.o
# ne.o -> ../drivers/net/ne.o
# ne2k-pci.o -> ../drivers/net/ne2k-pci.o
# nfs.o -> ../drivers/nfs.o
# nls_cp437.o -> ../drivers/nls_cp437.o
# nls_iso8859_1.o -> ../drivers/nls_iso8859_1.o
# paride.o -> ../drivers/block/paride/paride.o
# pcd.o -> ../drivers/block/paride/pcd.o
# pd.o -> ../drivers/block/paride/pd.o
# pf.o -> ../drivers/block/paride/pf.o
# pg.o -> ../drivers/block/paride/pg.o
# ppa.o -> ../drivers/scsi/ppa.o
# psaux.o -> ../drivers/char/psaux.o
# pt.o -> ../drivers/block/paride/pt.o
# raid0.o -> ../drivers/block/raid0.o
# raid1.o -> ../drivers/block/raid1.o
# raid5.o -> ../drivers/block/raid5.o
# rtl8139.o -> ../drivers/net/rtl8139.o
# scsi_mod.o -> ../drivers/scsi/scsi_mod.o
# scsi_syms.o -> ../drivers/scsi/scsi_syms.o
# sd_mod.o -> ../drivers/scsi/sd_mod.o
# serial.o -> ../drivers/char/serial.o
# sg.o -> ../drivers/scsi/sg.o
# smbfs.o -> ../drivers/smbfs.o
# sound.o -> ../drivers/sound/sound.o
# sr_mod.o -> ../drivers/scsi/sr_mod.o
# st.o -> ../drivers/scsi/st.o
# sysv.o -> ../drivers/sysv.o
# ufs.o -> ../drivers/ufs.o
