#!/bin/sh -x
# 09/06/2003

# TODO:- REALLY needs bash - eg. module symlinks, $UID
# TODO:- Need /sbin/genksyms (where from?) to get kernel module symbols

# NB:- Want no APM *AT ALL* for kernel to work on bochs
# NB:- Need EXPERIMENTAL stuff for the kernel automounter, or only
# NB: get to use minix fs (or presumably the first-selected fs)
# NB:- `make install` compresses the large vmlinux into a vmlinuz

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

modify_config()
{
	while [ "$1" ] ; do
		NAME=`echo $1 | sed 's/^_/CONFIG_/'`
		shift
		VALUE=$1
		shift

		cat .config \
			| sed "s%^[# ]*${NAME}[= ].*%#[${NAME} adjusted]%" \
			> tmp.$$
		mv tmp.$$ .config
		case ${VALUE} in
		#*)		;;	## ...ignore
		unset|UNSET)	echo "# ${NAME} is not set" >> .config ;;
		*)		echo "${NAME}=${VALUE}" >> .config ;;
		esac
	done
}

make_toolchain()
{
# PREPARE...
	[ -r Makefile.OLD ] || cp Makefile Makefile.OLD || exit 1
#	2.0.40-rc6 patch still thinks it's 2.0.40-rc5
	[ "$PKGVER" = 2.0.40-rc6 ] && sed 's/^EXTRAVERSION.*rc5/EXTRAVERSION=-rc6/' Makefile.OLD > Makefile || exit 1

	make mrproper || exit 1
	make include/linux/version.h || exit 1
	make symlinks || exit 1
	
	if [ -z "$TARGET_CPU" ] ; then
		echo "*** WARNING: Determining TARGET_CPU"
		TARGET_CPU=`ls -l include/asm | sed 's/.*-//'`
	fi

# CONFIGURE...
	grep -v "CONFIG_AUTODETECT_RAID" arch/${TARGET_CPU}/defconfig > .config || exit 1
	( cd include && ln -sf asm-${TARGET_CPU} ./asm ) || exit 1
	#yes "" | make config

	modify_config _EXPERIMENTAL y \
		_MODULES y	_MODVERSIONS unset	_KERNELD y \
		_MATH_EMULATION y \
		_MEM_STD y	_MEM_ENT unset	_MEM_SPECIAL unset \
		_MAX_MEMSIZE 1024 \
		\
		_NET y	_MAX_16M unset	_PCI y	_SYSVIPC unset \
		_BINFMT_AOUT y	_BINFMT_ELF y	_KERNEL_ELF y \
			_BINFMT_JAVA unset \
		_M386 y	_M486 unset	_M586 unset	_M686 unset \
		_APM y	_APM_CPU_IDLE y \
			_APM_IGNORE_USER_SUSPEND unset \
			_APM_DO_ENABLE unset \
			_APM_DISPLAY_BLANK y	_APM_POWER_OFF y \
			_APM_IGNORE_MULTIPLE_SUSPEND unset \
		\
		_BLK_DEV_FD y	_BLK_DEV_IDE y \
		_BLK_DEV_HD_IDE unset	_BLK_DEV_IDECD y \
		_BLK_DEV_IDETAPE unset	_BLK_DEV_IDEFLOPPY unset \
		_BLK_DEV_IDESCSI unset	_BLK_DEV_IDE_PCMCIA y \
		_BLK_DEV_CMD640 y	_BLK_DEV_CMD640_ENHANCED unset \
		_BLK_DEV_RZ1000 y	_BLK_DEV_TRITON y \
		_BLK_DEV_OFFBOARD unset	_IDE_CHIPSETS unset \
		_BLK_DEV_LOOP m \
		_BLK_DEV_MD y	_MD_LINEAR m	_MD_STRIPED m \
			_MD_MIRRORING m	_MD_RAID5 m \
		_BLK_DEV_RAM y	_BLK_DEV_INITRD y \
		_BLK_DEV_XD unset \
		_BLK_DEV_DAC960 unset	_BLK_CPQ_DA unset \
		_PARIDE m	_PARIDE_PD m	_PARIDE_PCD m	_PARIDE_PF m \
			_PARIDE_PT m	_PARIDE_PG m \
			_PARIDE_ATEN unset	_PARIDE_BPCK m \
			_PARIDE_COMM unset	_PARIDE_DSTR unset \
			_PARIDE_FIT2 unset	_PARIDE_FIT3 unset \
			_PARIDE_EPAT unset	_PARIDE_EPIA unset \
			_PARIDE_FRIQ unset	_PARIDE_FRPW unset \
			_PARIDE_KBIC unset	_PARIDE_KTTI unset \
			_PARIDE_ON20 unset	_PARIDE_ON26 unset \
		_BLK_DEV_HD unset \
		\
		_FIREWALL unset	_BRIDGE unset	_NET_ALIAS unset	_INET y \
		_IP_FORWARD unset	_IP_MULTICAST unset \
		_SYN_COOKIES unset	_IP_ACCT unset	_IP_ROUTER unset \
		_NET_IPIP unset	_INET_PCTCP unset	_INET_RARP unset \
		_NO_PATH_MTU_DISCOVERY unset \
		_IP_NOSR y	_SKB_LARGE y \
		_IPX unset	_ATALK unset	_AX25 unset	_NETLINK unset \
		\
		_SCSI m	_BLK_DEV_SD m	_CHR_DEV_ST m \
			_BLK_DEV_SR m	_CHR_DEV_SG m \
			_SCSI_MULTI_LUN y	_SCSI_CONSTANTS unset \
			_SCSI_7000FASST unset	_SCSI_ACARD unset \
			_SCSI_AHA152X unset	_SCSI_AHA1542 unset \
			_SCSI_AHA1740 unset	_SCSI_AIC7XXX unset \
			_SCSI_ADVANSYS m	_SCSI_IN2000 unset \
			_SCSI_AM53C974 unset	_SCSI_MEGARAID unset \
			_SCSI_BUSLOGIC unset	_SCSI_DTC3280 unset \
			_SCSI_EATA_DMA unset	_SCSI_EATA_PIO unset \
			_SCSI_EATA unset	_SCSI_FUTURE_DOMAIN unset \
			_SCSI_GENERIC_NCR5380 unset \
			_SCSI_INITIO unset	_SCSI_INIA100 unset \
			_SCSI_NCR53C406A unset	_SCSI_SYM53C416 unset \
			_SCSI_NCR53C7xx unset	_SCSI_NCR53C8XX unset \
			_SCSI_PPA m	_SCSI_PPA_HAVE_PEDANTIC y \
			_SCSI_PAS16 unset	_SCSI_PCI2000 unset \
			_SCSI_PCI2220I unset	_SCSI_PSI240I unset \
			_SCSI_QLOGIC_FAS unset \
			_SCSI_QLOGIC_ISP unset \
			_SCSI_SEAGATE unset	_SCSI_DC390T unset \
			_SCSI_T128 unset	_SCSI_TC2550 unset \
			_SCSI_U14_34F unset	_SCSI_ULTRASTOR unset \
			_SCSI_GDTH unset \
		\
		_NETDEVICES y	_DUMMY m \
			_EQUALIZER unset \
			_PLIP unset	_PPP unset \
			_SLIP unset	_NET_RADIO unset \
		_NET_ETHERNET y \
			_NET_VENDOR_3COM y \
			_EL1 unset	_EL2 unset	_EL3 m \
			_EL16 unset	_ELPLUS unset \
			_3C515 unset	_VORTEX m \
			_NET_VENDOR_SMC y \
			_WD80x3 m \
			_ULTRA m	_ULTRA32 m	_SMC9194 m \
		_NET_PCI y	_PCNET32 unset \
			_EEXPRESS_PRO m \
			_EEXPRESS_PRO100B m	_DE4X5 unset \
			_DEC_ELCP unset	_DGRS unset	_NE2K_PCI m \
			_YELLOWFIN unset	_RTL8139 m	_EPIC unset \
			_TLAN unset	_VIA_RHINE unset	_SHAPER unset \
			_ETH16I unset	_FMV18X unset	_ISI unset \
			_NI52 unset	_NI65 unset	_PCI_OPTIMIZE unset \
		_NET_ISA y \
			_LANCE unset	_AT1700 unset	_E2100 unset \
			_DEPCA unset	_EWRK3 unset	_EEXPRESS m \
			_HPLAN_PLUS unset	_HPLAN unset	_HP100 unset \
			_NE2000 m	_SK_G16 unset \
		_NET_EISA unset	_NET_POCKET unset	_TR unset \
			_FDDI unset	_ARCNET unset \
		_ISDN unset	_CD_NO_IDESCSI unset \
		\
		_QUOTA unset	_AUTOFS_FS y \
			_MINIX_FS y	_EXT_FS unset	_EXT2_FS m \
			_XIA_FS unset \
			_NLS y	_NLS_CODEPAGE_437 y \
				_NLS_ISO8859_1 m \
				_NLS_ISO8859_14 m \
				_NLS_ISO8859_15 m \
			_ISO9660_FS y	_FAT_FS y	_MSDOS_FS y \
			_UMSDOS_FS y	_VFAT_FS y \
		_PROC_FS y	_NFS_FS m	_SMB_FS m	_SMB_WIN95 y \
		_HPFS_FS m	_SYSV_FS m \
		_UFS_FS m	_BSD_DISKLABEL y	_SMD_DISKLABEL y \
			_AFFS_FS m	_AMIGA_PARTITION y \
		\
		_SERIAL m	_SERIAL_PCI unset	_DIGI unset	_CYCLADES unset \
			_STALDRV unset	_RISCOM8 unset \
		_PRINTER m	_SPECIALIX unset \
		_MOUSE y \
			_ATIXL_BUSMOUSE m	_BUSMOUSE m \
			_MS_BUSMOUSE m	_PSMOUSE m	_82C710_MOUSE y \
		_UMISC unset	_QIC02_TAPE unset	_FTAPE m \
		_WATCHDOG unset	_RTC unset \
		_SOUND m	_PAS unset	_SB y	_ADLIB unset \
			_MPU401 unset	_UART6850 unset	_PSS unset \
			_GUS unset	_GUS16 unset	_GUSMAX unset	_MSS unset \
			_SSCAPE unset	_TRIX unset	_MAD16 unset \
			_CS4232 unset	_MAUI unset \
		\
		_AUDIO y	_MIDI y	_LOWLEVEL_SOUND unset \
		_YM3812 Y \
		SBC_BASE 220	SBC_IRQ 7	SBC_DMA 1	SB_DMA2 5 \
			SB_MPU_BASE 0	SB_MPU_IRQ -1 \
			DSP_BUFFSIZE 65536 \
		_DLCI unset	_RCPCI unset	_SEEQ8005 unset \
		_PROFILE unset	_SADISTIC_KMALLOC unset	_SKB_CHECK unset
	cp .config config-apm || exit 1

	modify_config _APM unset \
			_APM_CPU_IDLE unset \
			_APM_IGNORE_USER_SUSPEND unset \
			_APM_DO_ENABLE unset \
			_APM_DISPLAY_BLANK unset \
			_APM_POWER_OFF unset \
			_APM_IGNORE_MULTIPLE_SUSPEND unset
	cp .config config-noapm || exit 1

	if [ -z "${INSTTEMP}" ] ; then
		echo "$0: INSTTEMP not set"
	else
		[ "${PKGNAME}" ] || exit 1
		if [ "${PKGVER}" ] ; then
			INSTPATH=linux-${PKGVER}
		else
			[ "${RELVER}" ] || exit 1
			INSTPATH=linux-${RELVER}
		fi
		mkdir -p ${INSTTEMP}/usr/src/${INSTPATH}
	
		echo "*** pwd" `pwd`
		tar cvf - .config * | ( cd ${INSTTEMP}/usr/src && \
			( cd ${INSTPATH} && tar xvf - ) ;\
			ln -sf ${INSTPATH} linux || exit 1 \
			) || exit 1
	
		mkdir -p ${INSTTEMP}/usr/include/asm || rm -rf ${INSTTEMP}/usr/include/asm/*
	
		cp include/asm/* ${INSTTEMP}/usr/include/asm
		cp -R include/linux ${INSTTEMP}/usr/include
	
##	-- some kernel header files include autoconf.h regardless of
##	-- whether we're building a kernel at the time or not :(
		touch ${INSTTEMP}/usr/include/linux/autoconf.h
		touch ${INSTTEMP}/usr/src/linux/include/linux/autoconf.h
	fi

#	make dep modules modules_install bzImage install
}

case "$1" in
distro-cross)
	make_toolchain || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_toolchain || exit 1
	;;
*)
	exit 1
	;;
esac
