#!/bin/sh
# 25/05/2003

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc \
		./configure +fhs +lang en \
		 || exit 1

	make src/Makefile
	[ -r src/Makefile.OLD ] || cp src/Makefile src/Makefile.OLD
	cat src/Makefile.OLD \
		| sed 's%-p /usr/%-p $(PREFIX)/usr/%' \
		> src/Makefile || exit 1

	make man2html/Makefile
	[ -r man2html/Makefile.OLD ] || cp man2html/Makefile man2html/Makefile.OLD
	cat man2html/Makefile.OLD \
		> man2html/Makefile || exit 1

	make man/Makefile
	[ -r man/Makefile.OLD ] || cp man/Makefile man/Makefile.OLD
	cat man/Makefile.OLD \
		> man/Makefile || exit 1

# BUILD...
# ...host utilities
	make CC=gcc -C src makemsg

# ...now the cross-compilation bit
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make || exit 1

# INSTALL...
	mkdir -p ${INSTTEMP}/usr/sbin
	make PREFIX=${INSTTEMP} install || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
#toolchain-host)
#	INSTTEMP=${TCTREE} make_tc_host || exit 1
#	;;
*)
	exit 1
	;;
esac
