#!/bin/sh
# 24/05/2003

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc \
		./configure --prefix=/usr --exec-prefix=/usr \
		 --build=`uname -m` --target=${TARGET_CPU} \
		 || exit 1

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make || exit 1

# INSTALL...
	make DESTDIR=${INSTTEMP} install || exit 1
}

make_tc_host()
{
# CONFIGURE...
	./configure --prefix=${INSTTEMP}/usr --exec-prefix=${INSTTEMP}/usr \
	 || exit 1

# BUILD...
	make || exit 1

# INSTALL...
	make BINDIR=${INSTTEMP}/usr/bin MANDIR=${INSTTEMP}/usr/man \
	 install || exit 1
	( cd ${INSTTEMP}/usr/bin && ( \
		ln -sf mawk awk \
	) || exit 1 ) || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac
