#!/bin/sh
# 24/05/2003

# TODO:- distro-cross parse errors?

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
## 'autoconf' causes 'configure' rebuild (recommended for CVS sources)
#	autoconf
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc \
		./configure --prefix=/usr \
		 --host=`uname -m` --target=${TARGET_CPU} \
		 || exit 1

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make || exit 1

# INSTALL...
	mkdir -p ${INSTTEMP}/usr/bin ${INSTTEMP}/usr/man/man1
	make prefix=${INSTTEMP}/usr install || exit 1
}

make_tc_host()
{
# CONFIGURE...
## 'autoconf' causes 'configure' rebuild (recommended for CVS sources)
#	autoconf
	./configure --prefix=${INSTTEMP}/usr || exit 1

# BUILD...
	make || exit 1

# INSTALL...
	make install || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac
