#!/bin/sh
# 04/07/2003

# TODO:- Note the SUBDIRS setting - we don't (can't?) make everything
# TODO:- netkit-rsh fails over vfork()

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		./configure \
		 --prefix=/usr --installroot=${INSTTEMP} \
		 --without-pam --without-readline \
		 || exit 1

	for MF in `grep -- '-o root' */*/Makefile | sed 's/:.*//'` ; do
		[ -r $MF.OLD ] || mv $MF ${MF}.OLD || exit 1
		cat $MF.OLD \
			| sed 's/-o root/${UIDOPTS}/' \
			| sed 's/-g root/${GIDOPTS}/' \
			> $MF
	done

	[ -r biff+comsat/comsat/Makefile.OLD ] \
		|| mv biff+comsat/comsat/Makefile biff+comsat/comsat/Makefile.OLD \
		|| exit 1
	cat biff+comsat/comsat/Makefile.OLD \
		| sed 's% $(MANDIR)% $(INSTALLROOT)/$(MANDIR)%' \
		> biff+comsat/comsat/Makefile || exit 1

# BUILD...

# NB:- no netkit-ntalk, bsd-finger, linux-ftpd, netwrite,
# NB: netkit-bootparamd, netkit-rusers, netkit-rwall, netkit-timed
	SUBDIRS="netkit-base netkit-rpc \
		netkit-ftp netkit-tftp \
		biff+comsat netkit-rwho \
		netkit-routed"
#	SUBDIRS="netkit-base netkit-rpc \
#		netkit-ntalk bsd-finger linux-ftpd netkit-ftp netwrite \
#		netkit-bootparamd netkit-tftp \
#		biff+comsat netkit-rusers netkit-rwho netkit-rwall \
#		netkit-routed netkit-rsh netkit-telnet netkit-timed"

	for SUB in ${SUBDIRS} ; do
		PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
			make -C ${SUB} \
			 CC=${TARGET_CPU}-uclibc-gcc CXX=${TARGET_CPU}-uclibc-g++ \
			 CFLAGS="-I${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/include/ncurses" \
			 CXXFLAGS="-I${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/include/ncurses" \
			 || exit 1
	done || exit 1

# INSTALL...
	mkdir -p ${INSTTEMP}/bin || exit 1
	mkdir -p ${INSTTEMP}/usr/bin ${INSTTEMP}/usr/sbin || exit 1
	mkdir -p ${INSTTEMP}/usr/man/man1 ${INSTTEMP}/usr/man/man5 ${INSTTEMP}/usr/man/man8 || exit 1

	for SUB in ${SUBDIRS} ; do
		make -C ${SUB} prefix=${INSTTEMP}/usr install || exit 1
	done || exit 1
}

#make_tc_host()
#{
#	./configure --prefix=${INSTTEMP}/usr || exit 1
#	make || exit 1
#	make DESTDIR=/ install || exit 1
#}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
#toolchain-host)
#	INSTTEMP=${TCTREE} make_tc_host || exit 1
#	;;
*)
	exit 1
	;;
esac
