#!/bin/sh
# 02/04/2003

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	CPPFLAGS=-D_GNU_SOURCE \
		./configure --prefix=/usr \
			--host=`uname -m` --target=${TARGET_CPU} \
			--disable-largefile || exit 1

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make CC=${TARGET_CPU}-uclibc-gcc || exit 1

# INSTALL...
	make prefix=${INSTTEMP}/usr install || exit 1
}

make_tc_host()
{
# CONFIGURE...
	CC=gcc CPPFLAGS=-D_GNU_SOURCE \
		./configure --prefix=${INSTTEMP}/usr || exit 1

# BUILD...
	make || exit 1

# INSTALL...
	make install || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	echo "BAD ARGS $*"
	exit 1
	;;
esac
