#!/bin/sh
# 26/06/2003

# TODO: "libtool: install: warning: remember to run `libtool --finish /usr/lib'"

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
# '--with-included-gettext' seems to get overridden :(
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc \
		./configure --prefix=/usr --bindir=/bin \
		 --build=`uname -m` --host=${TARGET_CPU} --target=${TARGET_CPU} \
		 --disable-largefile \
		 --with-included-gettext \
		 || exit 1

# BUILD...
#	cf. busybox-style Config.h!!
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make CC=${TARGET_CPU}-uclibc-gcc || exit 1

# INSTALL...
	make prefix=${INSTTEMP}/usr install || exit 1
}

make_tc_target()
{
# CONFIGURE...
# '--with-included-gettext' seems to get overridden :(
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc \
		./configure \
		 --prefix=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc \
		 --bindir=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin \
		 --build=`uname -m` --host=${TARGET_CPU} --target=${TARGET_CPU} \
		 --disable-largefile \
		 --with-included-gettext \
		 || exit 1

# BUILD...
#	cf. busybox-style Config.h!!
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make CC=${TARGET_CPU}-uclibc-gcc || exit 1

# INSTALL...
	make prefix=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc install || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-cross)
	INSTTEMP=${TCTREE} make_tc_target || exit 1
	;;
*)
	exit 1
	;;
esac
