#!/bin/sh
# 27/05/2003

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc \
	 ac_cv_func_setvbuf_reversed=no \
		./configure --prefix=/usr --bindir=/bin \
		 --localstatedir=/var \
		 --host=`uname -m` --target=${TARGET_CPU} \
		 || exit 1

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make || exit 1

# INSTALL...
	make DESTDIR=${INSTTEMP} install || exit 1
	( cd ${INSTTEMP} && ( \
		( cd bin && ln -sf test '[' ) ;\
		mkdir -p var/run ;\
		touch var/run/utmp \
	) || exit 1 ) || exit 1
}

make_tc_host()
{
# CONFIGURE...
	CC=gcc \
		./configure \
		 --prefix=${INSTTEMP}/usr --bindir=${INSTTEMP}/bin \
		 --localstatedir=${INSTTEMP}/var \
		 || exit 1

# BUILD...
	make || exit 1

# INSTALL...
	make install || exit 1
	( cd ${INSTTEMP} && ( \
		( cd bin && ln -sf test '[' ) ;\
		mkdir -p var/run ;\
		touch var/run/utmp \
	) || exit 1 ) || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac
