#!/bin/sh
# 04/07/2003

#TODO: seems to 'tcbuild' happily (...er, test for real?)

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc \
		./configure --prefix=/usr || exit 1

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make || exit 1

# INSTALL...
	make DESTDIR=${INSTTEMP} install || exit 1
}

make_tc_target()
{
# NATIVE
	./configure --prefix=${TCTREE}/usr || exit 1
	[ -r src/slmisc.c.OLD ] || cp src/slmisc.c src/slmisc.c.OLD \
		|| exit 1
	cat src/slmisc.c.OLD > src/slmisc.c
	[ -r src/Makefile.OLD ] || cp src/Makefile src/Makefile.OLD \
		|| exit 1
	cat src/Makefile.OLD > src/Makefile

	make || exit 1
	make runtests || exit 1
	make install || exit 1

# CONFIGURE...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc \
		./configure --prefix=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/usr || exit 1
	make clean || exit 1

	[ -r src/slmisc.c.OLD ] || cp src/slmisc.c src/slmisc.c.OLD \
		|| exit 1
	cat src/slmisc.c.OLD \
		| sed 's%^extern int __libc_enable_secure;%/* no __libc_enable_secure in uClibc%' \
		| sed "s%^# *define HAVE___LIBC_ENABLE_SECURE 1%/* don't define HAVE_LIBC_ENABLE_SECURE therefore! */%" \
		> src/slmisc.c || exit 1

	[ -r src/Makefile.OLD ] || cp src/Makefile src/Makefile.OLD \
		|| exit 1
	cat src/Makefile.OLD \
		| sed "s% -c % -c -nostdinc -I${TCTREE}/usr/include -I${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/include -I${TCTREE}/usr/lib/gcc-lib/i686-linux/2.95.3/include/ %" \
		> src/Makefile || exit 1

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make || exit 1

# INSTALL...
	make install || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-cross)
	INSTTEMP=${TCTREE} make_tc_target || exit 1
	;;
*)
	exit 1
	;;
esac
