#!/bin/sh
# 16/06/2003

# TODO: - Seems to 'tcbuild' happily (...er, test for real?)
# TODO: - Seeks va_copy() during cross compile, but "cannot run" test

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 slrn_cv_va_copy=no \
	 slrn_cv___va_copy=no \
	 slrn_cv_va_val_copy=no \
	 CC=${TARGET_CPU}-uclibc-gcc \
		./configure --prefix=/usr || exit 1

	[ -r src/Makefile.OLD ] || mv src/Makefile src/Makefile.OLD
	cat src/Makefile.OLD \
		| sed 's% -I. % -I${INCLROOT}/usr/include -I. %' \
		| sed 's%-L/usr/lib -lslang%-L${INCLROOT}/usr/lib -lslang -ldl%' \
		> src/Makefile || exit 1

# BUILD...
# ...start with a native chkslang:
	make -C intl CC=gcc libintl.a || exit 1
	make -C src INCLROOT=${TCTREE} CC=gcc chkslang || exit 1
	cp src/chkslang ./ || exit 1

# ...now rebuild everything (but targetted sanely) up to the same point
	rm -rf `find ./ -name "*.[oa]"` || exit 1
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make -C intl libintl.a || exit 1
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make -C src INCLROOT=${TCTREE} chkslang || exit 1
# ...and replace the native chkslang.
	touch chkslang || exit 1
	mv chkslang src/ || exit 1

# ...continue cross-build:
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make INCLROOT=${TCTREE} all || exit 1

# INSTALL...
	make DESTDIR=${INSTTEMP} install || exit 1
}

make_tc_host()
{
# CONFIGURE...
	./configure --prefix=${INSTTEMP}/usr || exit 1
#	# --with-slang-library=DIR
#	# --with-slang-includes=DIR
#	# --with-slrnpull
#	# --enable-inews | --enable-force-inews

# BUILD...
	make || exit 1
#	strip src/slrn src/slrnpull

# INSTALL...
	make install || exit 1
#	make install-contrib || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac
