#!/bin/sh
# 06/04/2003

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

do_prelim()
{
	mkdir -p ${INSTTEMP}/usr/sbin
	mkdir -p ${INSTTEMP}/usr/man/man8
}

make_build()
{
# CONFIGURE...
	do_prelim

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make CC=${TARGET_CPU}-uclibc-gcc

# INSTALL...
	cp smartctl ${INSTTEMP}/usr/sbin/
	cp smartd ${INSTTEMP}/usr/sbin/
	cp smart*.8 ${INSTTEMP}/usr/man/man8/
}

make_tc_host()
{
# CONFIGURE...
	do_prelim
	./configure --prefix=${INSTTEMP}/usr || exit 1

# BUILD...
	make || exit 1

# INSTALL...
	make install || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac
