#!/bin/sh
# 05/06/2003

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

do_prelim()
{
	[ -r Makefile.OLD ] || cp Makefile Makefile.OLD
	cat Makefile.OLD \
		| sed 's/^CC[ 	]*=.*/CC=${CROSS}gcc/' \
		| sed 's/ *-D_FILE_OFFSET_BITS=64//' \
		> Makefile

	[ -r memdisk/Makefile.OLD ] || cp memdisk/Makefile memdisk/Makefile.OLD
	cat memdisk/Makefile.OLD \
		| sed 's/^CC[ 	]*=.*/CC=${CROSS}gcc/' \
		> memdisk/Makefile

	[ -r sample/Makefile.OLD ] || cp sample/Makefile sample/Makefile.OLD
	cat sample/Makefile.OLD \
		| sed 's/^CC[ 	]*=.*/CC=${CROSS}gcc/' \
		> sample/Makefile

	[ -r syslinux-nomtools.c.OLD ] || cp syslinux-nomtools.c syslinux-nomtools.c.OLD
}

make_build()
{
# CONFIGURE...
	do_prelim
	cat syslinux-nomtools.c.OLD \
		| sed 's%#define _LARGEFILE64_SOURCE.*%//#define _LARGEFILE64_SOURCE...%' \
		| sed 's%|O_LARGEFILE%/* | O_LARGEFILE */%' \
		> syslinux-nomtools.c

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make CROSS=${TARGET_CPU}-uclibc- \
		 || exit 1

# INSTALL...
	make INSTALLROOT=${INSTTEMP} install || exit 1
}

make_tc_host()
{
# CONFIGURE...
	do_prelim
	cat syslinux-nomtools.c.OLD \
		> syslinux-nomtools.c

# BUILD...
	make || exit 1

# INSTALL...
	make INSTALLROOT=${INSTTEMP} install || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac
