#!/bin/sh
# 18/06/2003

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
	 CC=${TARGET_CPU}-uclibc-gcc \
		./configure --prefix=/usr \
		 --host=`uname -m` --target=${TARGET_CPU} \
		 --bindir=/bin \
		 --libexecdir=/usr/bin \
		 --disable-largefile --disable-nls || exit 1

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make || exit 1

# INSTALL...
	make prefix=${INSTTEMP}/usr bindir=${INSTTEMP}/bin libexecdir=${INSTTEMP}/usr/bin install || exit 1
}

make_tc_host()
{
	## tries to use 'cc' by default. Assume cc != gcc:
	CC=`which gcc` ./configure --prefix=${INSTTEMP}/usr \
		--bindir=/bin \
		--libexecdir=/usr/bin \
		--disable-largefile --disable-nls || exit 1
	make || exit 1
	make prefix=${INSTTEMP}/usr bindir=${INSTTEMP}/bin libexecdir=${INSTTEMP}/usr/bin install || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac
