#!/bin/sh
# 24/05/2003

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} CC=${TARGET_CPU}-uclibc-gcc \
		./configure \
		 --prefix=/usr --bindir=/bin \
		 --host=`uname -m` --build=${TARGET_CPU} \
		 || exit 1

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} CC=${CROSS_PREFIX}-gcc \
		make || exit 1

# INSTALL...
	make DESTDIR=${INSTTEMP} install || exit 1
}

make_tc_host()
{
# CONFIGURE...
	./configure \
	 --prefix=${INSTTEMP}/usr --bindir=${INSTTEMP}/bin \
	 || exit 1

# BUILD...
	make || exit 1

# INSTALL...
	make install || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac
