#!/bin/sh
# 11/06/2003

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	[ "${TCTREE}" ] || exit 1
	[ -d "${TCTREE}/usr/src/linux" ] || exit 1
	CROSS_PREFIX=${TARGET_CPU}-uclibc

	make clean
	[ -r Rules.mak.OLD ] || cp Rules.mak Rules.mak.OLD
# Some target-environment stuff uses HOSTCC still. D'oh!
	cat Rules.mak.OLD \
		| sed 's/HOSTCC=gcc/HOSTCC=${CROSS}gcc/' \
		> Rules.mak
# Some tweaks we want in .config
	echo -n '' > .config
	echo 'KERNEL_SOURCE="'${TCTREE}'/usr/src/linux"' >> .config
	echo '# UCLIBC_HAS_LFS is not set' >> .config
	echo 'MALLOC=y' >> .config
	echo '# MALLOC_930716 is not set' >> .config
	echo '# UNIX98PTY_ONLY is not set' >> .config
	echo '# ASSUME_DEVPTS is not set' >> .config
	echo 'SHARED_LIB_LOADER_PATH="/lib"' >> .config
# ...additional stuff here (08/06/2003)
	echo 'UCLIBC_HAS_RPC=y' >> .config
	echo 'UCLIBC_HAS_FULL_RPC=y' >> .config
# ...now bring .config fully up to date with everything at default
	yes '' | make oldconfig || exit 1

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make CROSS=${CROSS_PREFIX}- HOSTCC=${CROSS_PREFIX}-gcc \
		 || exit 1

# INSTALL...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make CROSS=${CROSS_PREFIX}- \
		 PREFIX=${RUNTIME_INSTTEMP} \
		 install_target || exit 1

	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make CROSS=${CROSS_PREFIX}- \
		 PREFIX=${WRAPPERS_INSTTEMP} \
		 install || exit 1

	mkdir -p ${WRAPPERS_INSTTEMP}/usr/include || exit 1
	( cd ${WRAPPERS_INSTTEMP}/usr/include && ln -sf ../${TARGET_CPU}-linux-uclibc/include/* ./ ) || exit 1
	( cd ${WRAPPERS_INSTTEMP}/usr/${TARGET_CPU}-linux-uclibc && ( \
		sed "s%${TCTREE}%%" bin/${TARGET_CPU}-uclibc-ld > tmp.$$ ;\
		mv tmp.$$ bin/${TARGET_CPU}-uclibc-ld ;\
		chmod a+rx bin/${TARGET_CPU}-uclibc-ld ;\
		ls -l ` find bin -type l ` | cut -c57- | while read LINK ; do \
			set -- $LINK ;\
			( cd bin && ln -sf `echo $3 | sed "s%${TCTREE}%%"` ./`basename $1` ) ;\
		done ;\
		ls -l ` find usr/bin -type l ` | cut -c57- | while read LINK ; do \
			set -- $LINK ;\
			( cd usr/bin && ln -sf `echo $3 | sed "s%${TCTREE}%%"` ./`basename $1` ) ;\
		done ;\
	) || exit 1 ) || exit 1
}

make_tc_host()
{
# CONFIGURE...
	[ "${TCTREE}" ] || exit 1
	[ -d "${TCTREE}/usr/src/linux" ] || exit 1

	make clean
# Some tweaks we want in .config. Note additional stuff.
	echo -n '' > .config
	echo 'KERNEL_SOURCE="'${TCTREE}'/usr/src/linux"' >> .config
	echo '# UCLIBC_HAS_LFS is not set' >> .config
	echo 'MALLOC=y' >> .config
	echo '# MALLOC_930716 is not set' >> .config
	echo '# UNIX98PTY_ONLY is not set' >> .config
	echo '# ASSUME_DEVPTS is not set' >> .config
	echo 'SHARED_LIB_LOADER_PATH="/lib"' >> .config
# ...additional stuff here (08/06/2003)
	echo 'UCLIBC_HAS_RPC=y' >> .config
	echo 'UCLIBC_HAS_FULL_RPC=y' >> .config
# ...now bring .config fully up to date with everything at default
	yes '' | make oldconfig || exit 1

# BUILD...
	make CROSS='' HOSTCC=gcc \
		 DEVEL_PREFIX=${INSTTEMP}/usr/${TARGET_CPU}-linux-uclibc \
		 || exit 1

# INSTALL...
	make \
		 DEVEL_PREFIX=${INSTTEMP}/usr/${TARGET_CPU}-linux-uclibc \
		 install || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac
