#!/bin/sh
# 01/04/2003

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
	do_prelim
	[ -d ${INSTTEMP}/usr/src/linux ]
	CROSS_PREFIX=${TARGET_CPU}-uclibc
##	--
	make clean
	make defconfig
	[ -r .config.OLD ] || cp .config .config.OLD
	[ -r include/bits/uClibc_config.h.OLD ] || cp include/bits/uClibc_config.h include/bits/uClibc_config.h.OLD

	cat .config.OLD \
		| sed "s%/usr/src/linux%${TCTREE}/usr/src/linux%" \
		| sed "s%UCLIBC_HAS_LFS=y%# UCLIBC_HAS_LFS is not set%" \
		| sed "s%# MALLOC is not set%MALLOC=y%" \
		| sed "s%MALLOC_930716=y%# MALLOC_930716 is not set%" \
		| sed "s%UNIX98PTY_ONLY=y%# UNIX98PTY_ONLY is not set%" \
		| sed "s%ASSUME_DEVPTS=y%# ASSUME_DEVPTS is not set%" \
		| sed 's%SHARED_LIB_LOADER_PATH=.*%SHARED_LIB_LOADER_PATH="/lib"%' \
		> .config
	echo "# UCLIBC_MALLOC_DEBUGGING is not set" >> .config
##	--
	cat include/bits/uClibc_config.h.OLD \
		| sed 's/.*__UNIX98PTY_ONLY__/\/\/UNIX98PTY_ONLY: /' \
		| sed 's/.*__UCLIBC_HAS_LFS__/\/\/UCLIBC_HAS_LFS: /' \
		| sed "s%__KERNEL_SOURCE__.*%__KERNEL_SOURCE__ \"${TCTREE}/usr/src/linux/\"%" \
		> include/bits/uClibc_config.h
##	--
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make CROSS=${CROSS_PREFIX}- \
		 DEVEL_PREFIX=/usr/${TARGET_CPU}-linux-uclibc || exit 1
	mkdir -p ${INSTTEMP}/lib
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make CROSS=${CROSS_PREFIX}- \
		 DEVEL_PREFIX=/usr/${TARGET_CPU}-linux-uclibc \
		 SYSTEM_DEVEL_PREFIX=/usr/${TARGET_CPU}-linux-uclibc \
		 PREFIX=${INSTTEMP} \
		 install_target || exit 1
}

make_tc_host()
{
	do_prelim
	[ -d ${INSTTEMP}/usr/src/linux ]
	[ "TARGET_CPU${TARGET_CPU}" != "TARGET_CPU" ]
##	--
	make clean
	make defconfig
	[ -r .config.OLD ] || cp .config .config.OLD
	[ -r include/bits/uClibc_config.h.OLD ] || cp include/bits/uClibc_config.h include/bits/uClibc_config.h.OLD

	cat .config.OLD \
		| sed "s%/usr/src/linux%${TCTREE}/usr/src/linux%" \
		| sed "s%UCLIBC_HAS_LFS=y%# UCLIBC_HAS_LFS is not set%" \
		| sed "s%# MALLOC is not set%MALLOC=y%" \
		| sed "s%MALLOC_930716=y%# MALLOC_930716 is not set%" \
		| sed "s%UNIX98PTY_ONLY=y%# UNIX98PTY_ONLY is not set%" \
		| sed "s%ASSUME_DEVPTS=y%# ASSUME_DEVPTS is not set%" \
		| sed 's%SHARED_LIB_LOADER_PATH=.*%SHARED_LIB_LOADER_PATH="/lib"%' \
		> .config
	echo "# UCLIBC_MALLOC_DEBUGGING is not set" >> .config
##	--
	cat include/bits/uClibc_config.h.OLD \
		| sed 's/.*__UNIX98PTY_ONLY__/\/\/UNIX98PTY_ONLY: /' \
		| sed 's/.*__UCLIBC_HAS_LFS__/\/\/UCLIBC_HAS_LFS: /' \
		| sed "s%__KERNEL_SOURCE__.*%__KERNEL_SOURCE__ \"${TCTREE}/usr/src/linux/\"%" \
		> include/bits/uClibc_config.h
##	--
	make \
		DEVEL_PREFIX=${INSTTEMP}/usr/${TARGET_CPU}-linux-uclibc || exit 1
	make \
		DEVEL_PREFIX=${INSTTEMP}/usr/${TARGET_CPU}-linux-uclibc \
		install || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac
