#!/bin/sh
# 03/07/2003

# TODO:- runtime claims "Unable to locale(sic) certbegin.o provided
# TOOD: by gcc" (it's in /usr/lib)

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	[ "${TCTREE}" ] || exit 1
	[ -d "${TCTREE}/usr/src/linux" ] || exit 1
	CROSS_PREFIX=${TARGET_CPU}-uclibc

	make clean
	[ -r extra/gcc-uClibc/Makefile.OLD ] \
		|| cp extra/gcc-uClibc/Makefile extra/gcc-uClibc/Makefile.OLD || exit 1
	cat extra/gcc-uClibc/Makefile.OLD \
		| sed 's/HOST//g' \
		| sed 's%^GCC_BIN.*%GCC_BIN=/usr/bin/gcc%' \
		> extra/gcc-uClibc/Makefile || exit 1

	echo -n '' > .config
	echo 'KERNEL_SOURCE="'${TCTREE}'/usr/src/linux"' >> .config
	echo '# UCLIBC_HAS_LFS is not set' >> .config
	echo 'MALLOC=y' >> .config
	echo '# MALLOC_930716 is not set' >> .config
	echo '# UNIX98PTY_ONLY is not set' >> .config
	echo '# ASSUME_DEVPTS is not set' >> .config
	echo 'SHARED_LIB_LOADER_PATH="/lib"' >> .config
# ...additional stuff here (08/06/2003, v0.9.19-3)
	echo 'UCLIBC_HAS_RPC=y' >> .config
	echo 'UCLIBC_HAS_FULL_RPC=y' >> .config
# ...yet more (17/06/2003, v0.9.19-4)
	echo 'DO_C99_MATH=y' >> .config
	echo 'UCLIBC_HAS_IPV6=y' >> .config
# ...now bring .config fully up to date with everything else at default
	yes '' | make oldconfig || exit 1

# BUILD...
# ...setting HOSTCC=${CROSS}-gcc fixes i386-uclibc-ldd:
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make CROSS=${CROSS_PREFIX}- HOSTCC=${CROSS_PREFIX}-gcc \
		 || exit 1

# INSTALL...
# ...need to set HOSTCC here too, to have sane i386-uclibc-ldd:
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make CROSS=${CROSS_PREFIX}- HOSTCC=${CROSS_PREFIX}-gcc \
		 PREFIX=${WRAPPERS_INSTTEMP} \
		 install || exit 1

	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make CROSS=${CROSS_PREFIX}- \
		 PREFIX=${RUNTIME_INSTTEMP} \
		 install_target || exit 1

	mkdir -p ${WRAPPERS_INSTTEMP}/usr/include || exit 1
	( cd ${WRAPPERS_INSTTEMP}/usr/include && ln -sf ../${TARGET_CPU}-linux-uclibc/include/* ./ ) || exit 1

# ...handle assumptions made about the toolchain and source-extract
# directory being accessible in the target environment. ld ends up
# calling itself recursively :(
	( cd ${WRAPPERS_INSTTEMP}/usr/${TARGET_CPU}-linux-uclibc/bin &&
		cat ${TARGET_CPU}-uclibc-ld \
			| sed "s%${TCTREE}%%" \
			| sed "s%/usr/${TARGET_CPU}-linux-uclibc/bin/${TARGET_CPU}-uclibc-%/usr/bin/%" \
			| sed "s/ *-L[^ ]*$//" \
			> tmp.$$ &&
		mv tmp.$$ ${TARGET_CPU}-uclibc-ld &&
		chmod a+rx ${TARGET_CPU}-uclibc-ld &&

		find ./ -type l | while read LINK ; do
			set -- `ls -l $LINK | cut -c57-`
			case $3 in
			${TARGET_CPU}*) ;;
			*) ln -sf /usr/bin/`basename $3 | sed 's/.*-//'` $1 ;;
			esac
		done || exit 1
	) || exit 1

	( cd ${WRAPPERS_INSTTEMP}/usr/${TARGET_CPU}-linux-uclibc/usr/bin &&
		find ./ -type l | while read LINK ; do
			set -- `ls -l $LINK | cut -c57-`
			case $3 in
			${TCTREE}*) ln -sf /usr/bin/`basename $3 | sed 's/.*-//'` $1 ;;
			*) ;;
			esac
		done || exit 1
	) || exit 1
}

make_tc_host()
{
# CONFIGURE...
	[ "${TCTREE}" ] || exit 1
	[ -d "${TCTREE}/usr/src/linux" ] || exit 1

	make clean
# Some tweaks we want in .config. Note additional stuff.
	echo -n '' > .config
	echo 'KERNEL_SOURCE="'${TCTREE}'/usr/src/linux"' >> .config
	echo '# UCLIBC_HAS_LFS is not set' >> .config
	echo 'MALLOC=y' >> .config
	echo '# MALLOC_930716 is not set' >> .config
	echo '# UNIX98PTY_ONLY is not set' >> .config
	echo '# ASSUME_DEVPTS is not set' >> .config
	echo 'SHARED_LIB_LOADER_PATH="/lib"' >> .config
# ...additional stuff here (08/06/2003)
	echo 'UCLIBC_HAS_RPC=y' >> .config
	echo 'UCLIBC_HAS_FULL_RPC=y' >> .config
# ...yet more (17/06/2003, v0.9.19-4)
	echo 'DO_C99_MATH=y' >> .config
	echo 'UCLIBC_HAS_IPV6=y' >> .config
# ...now bring .config fully up to date with everything else at default
	yes '' | make oldconfig || exit 1

# BUILD...
	make CROSS='' HOSTCC=gcc \
		 DEVEL_PREFIX=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc \
		 || exit 1

# INSTALL...
	make \
		 DEVEL_PREFIX=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc \
		 install || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac
