#!/bin/sh
# 19/05/2003

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
	[ "${TCTREE}" ] || exit 1
	[ -d "${TCTREE}/usr/src/linux" ] || exit 1
	CROSS_PREFIX=${TARGET_CPU}-uclibc

	make clean
	[ -r Rules.mak.OLD ] || cp Rules.mak Rules.mak.OLD
# Some target-environment stuff uses HOSTCC still. D'oh!
	cat Rules.mak.OLD \
		| sed 's/HOSTCC=gcc/HOSTCC=${CROSS}gcc/' \
		> Rules.mak
# Some tweaks we want in .config
	echo -n '' > .config
	echo 'KERNEL_SOURCE="'${TCTREE}'/usr/src/linux"' >> .config
	echo '# UCLIBC_HAS_LFS is not set' >> .config
	echo 'MALLOC=y' >> .config
	echo '# MALLOC_930716 is not set' >> .config
	echo '# UNIX98PTY_ONLY is not set' >> .config
	echo '# ASSUME_DEVPTS is not set' >> .config
	echo 'SHARED_LIB_LOADER_PATH="/lib"' >> .config
# ...now bring .config fully up to date with everything at default
	yes '' | make defconfig || exit 1

	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make CROSS=${CROSS_PREFIX}- HOSTCC=${CROSS_PREFIX}-gcc \
		 || exit 1

	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make PREFIX=${RUNTIME_INSTTEMP} \
		 install_target || exit 1

	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make PREFIX=${WRAPPERS_INSTTEMP} \
		 CROSS=${CROSS_PREFIX}- \
		 install || exit 1

	( cd ${WRAPPERS_INSTTEMP}/usr/${TARGET_CPU}-linux-uclibc && ( \
		sed "s%${TCTREE}%%" bin/${TARGET_CPU}-uclibc-ld > tmp.$$ ;\
		mv tmp.$$ bin/${TARGET_CPU}-uclibc-ld ;\
		chmod a+rx bin/${TARGET_CPU}-uclibc-ld ;\
		ls -l ` find bin -type l ` | cut -c57- | while read LINK ; do \
			set -- $LINK ;\
			( cd bin && ln -sf `echo $3 | sed "s%${TCTREE}%%"` ./`basename $1` ) ;\
		done ;\
		ls -l ` find usr/bin -type l ` | cut -c57- | while read LINK ; do \
			set -- $LINK ;\
			( cd usr/bin && ln -sf `echo $3 | sed "s%${TCTREE}%%"` ./`basename $1` ) ;\
		done ;\
	) || exit 1 ) || exit 1
}

make_tc_host()
{
	[ "${TCTREE}" ] || exit 1
#	[ -d "${TCTREE}/usr/src/linux" ] || exit 1

	make clean
# Some tweaks we want in .config
	echo -n '' > .config
	echo 'KERNEL_SOURCE="/usr/src/linux"' >> .config
	echo '# UCLIBC_HAS_LFS is not set' >> .config
	echo 'MALLOC=y' >> .config
	echo '# MALLOC_930716 is not set' >> .config
	echo '# UNIX98PTY_ONLY is not set' >> .config
	echo '# ASSUME_DEVPTS is not set' >> .config
	echo 'SHARED_LIB_LOADER_PATH="/lib"' >> .config
# ...now bring .config fully up to date with everything at default
	yes '' | make defconfig || exit 1

		make CROSS= HOSTCC=gcc \
		 || exit 1

		make PREFIX=${INSTTEMP} \
		 install_target || exit 1

		make PREFIX=${INSTTEMP} \
		 install || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac
