#!/bin/sh
# 05/07/2003

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

make_build()
{
# CONFIGURE...
	[ -r Makefile.OLD ] || cp Makefile Makefile.OLD
	cat Makefile.OLD \
		| sed 's%^GPP=g++%GPP=$${CROSS}g++%' \
		| sed 's%^GCC=gcc%GCC=$${CROSS}gcc%' \
		> Makefile

# umsdos_fs04.h assumes various __kernel_* definitions need to be
# made; they are, however, *subsequently* imported by inclusion of
# certain uClibc header files. Engineer sane use of uClibc's defns:
	[ -r include/umsdos_fs04.h.OLD ] || cp include/umsdos_fs04.h include/umsdos_fs04.h.OLD
	cat > include/umsdos_fs04.h <<EOF
#include <bits/kernel_types.h>
EOF
	cat include/umsdos_fs04.h.OLD \
		| sed 's%^typedef%//typedef%' \
		>> include/umsdos_fs04.h

	[ -r include/ums_config.h.OLD ] || cp include/ums_config.h include/ums_config.h.OLD
	cat include/ums_config.h.OLD \
		| sed 's%^#define BE_UVFAT.*%#define BE_UVFAT 0%' \
		| sed 's%^#define GNU_HACK 0.*%#define GNU_HACK 1%' \
		| sed 's%^#define KERN_22X%/* #define KERN_22X */%' \
		> include/ums_config.h

# ...need _I386_STRING_H_ for uClibc (see util/Makefile, __KERNEL__)
	[ -r util/Makefile.OLD ] || cp util/Makefile util/Makefile.OLD
	cat util/Makefile.OLD \
		| sed "s%/usr/src/linux%${TCTREE}/usr/src/linux%" \
		| sed "s/ -I/ -D_I386_STRING_H_ -I/" \
		| sed "s%^INC.*%INC=-nostdinc -I${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/include -I${TCTREE}/usr/lib/gcc-lib/`uname -m`-linux/2.95.3/include -I${TCTREE}/usr/include -I../include%" \
		> util/Makefile

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make CROSS=${TARGET_CPU}-uclibc- all || exit 1

# INSTALL...
	mkdir -p ${INSTTEMP}/usr/sbin
	cp util/umssync ${INSTTEMP}/usr/sbin/ || exit 1
	( cd ${INSTTEMP}/usr/sbin && ln -sf umssync umsssetup)
	mkdir -p ${INSTTEMP}/usr/man/man8
	cat util/umssync.8 | gzip -9 > ${INSTTEMP}/usr/man/man8/umssync.8.gz
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
#toolchain-host)
#	INSTTEMP=${TCTREE} make_tc_host || exit 1
#	;;
*)
	exit 1
	;;
esac
