#!/bin/sh
# 18/06/2003

[ "${SYSCONF}" ] && . ${SYSCONF}
[ "${PKGFILE}" ] && . ${PKGFILE}

do_prelim()
{
	mkdir -p ${INSTTEMP}/usr/bin || exit 1
	mkdir -p ${INSTTEMP}/usr/man/man1 || exit 1
}

make_build()
{
# CONFIGURE...
	do_prelim || exit 1

# BUILD...
	PATH=${TCTREE}/usr/${TARGET_CPU}-linux-uclibc/bin:${PATH} \
		make -f unix/Makefile CC=${TARGET_CPU}-uclibc-gcc generic || exit 1

# INSTALL...
	for FILE in unzip funzip unzipsfx ; do \
		cp $FILE ${INSTTEMP}/usr/bin/ || exit 1 ;\
	done || exit 1
	cp man/*.1 ${INSTTEMP}/usr/man/man1/ || exit 1
}

make_tc_host()
{
# CONFIGURE...
	do_prelim || exit 1

# BUILD...
	make -f unix/Makefile CC=gcc generic || exit 1

# INSTALL...
	for FILE in unzip funzip unzipsfx ; do \
		cp $FILE ${INSTTEMP}/usr/bin/ || exit 1 ;\
	done || exit 1
	cp man/*.1 ${INSTTEMP}/usr/man/man1/ || exit 1
}

case "$1" in
distro-cross)
	make_build || exit 1
	;;
toolchain-host)
	INSTTEMP=${TCTREE} make_tc_host || exit 1
	;;
*)
	exit 1
	;;
esac
